static char h_rcsid[]="$Id: h.h,v 1.3 1998/10/13 15:08:49 green Exp $";

/*----------------------------------------------------
 * h.h Tom Green Mon Jan 31 10:44:31 1994
 *
 * Copyright 1993
 *
 * SUPER COMPUTER COMPUTATIONS RESEARCH INSTITUTE
 *            FLORIDA STATE UNIVERSITY
 *
 *
 * SCRI representatives make no claims about the
 * suitability of this software for any purpose.
 * It is provided "as is" without express or
 * implied warranty.
 *
 * $Log: h.h,v $
 * Revision 1.3  1998/10/13 15:08:49  green
 * Solaris 2.6 support - hopefully, as I don't have access to one...
 *
 * Revision 1.2  1998/10/13 14:23:13  green
 * Patching Solaris defines - shooting in the dark here as I don't have access to
 * a Solaris 2.5 box
 *
 * Revision 1.1.1.1  1998/08/18 14:39:12  green
 * DQS 3.2.0.5 WIP Import
 *
 * Revision 1.2  1997/08/08 19:51:25  decker
 * Patch by Janssen for Linux
 *
 * Revision 1.1.1.1  1997/04/10 15:10:35  green
 * DQS 3.1.3.4.1 Distribution
 *
 * Revision 3.16  1997/03/25 18:13:50  nrl
 * removed redundant definitions and some typing garbage
 *
 * Revision 3.15  1997/03/25 16:48:02  nrl
 * Stripped garbage from Makefile.proto.in
 *
 * Revision 3.14  1996/11/20 23:05:01  nrl
 * Several fixes submitted by or as a result of investigations by
 * Ron Lee, Bodo Bechenback, Guntram Wolski and Frank Dwyyer.
 *
 * Revision 3.13  1996/07/09  22:05:51  nrl
 * Added include path for openwin on SOLARIS platforms
 *
 * Revision 3.12  1996/03/14  03:16:52  nrl
 * merge in subordinate queues and consumable resource changes
 *
 * Revision 3.11  1996/03/12  17:13:01  nrl
 * removed aborts and replaced with an error messaging scheme
 * to send email to the dqs adminsitrator and wait for
 * actions by that administrator
 *
 * Revision 3.10  1996/02/07  13:08:28  nrl
 * Added "process leader" and TMP_FILES link capability
 *
 * Revision 3.8  1995/05/29  18:09:01  nrl
 * More solaris stuff GAGGHH had to differentiate more cases of
 * solaris2.3 and solaris2.4 stuff
 *
 * Revision 3.7  1994/06/14  19:15:04  green
 * yanked "#include <arpa/inet.h>"
 *
 * Revision 3.6  1994/06/02  18:49:30  green
 * more portability headaches brought on by Sun Solaris
 * now including "Makefile.h" which is generated by config.guess
 * so we can stick in all sorts of #ifdefs in to handle Sloaris
 *
 * Revision 3.5  1994/06/02  13:44:33  green
 * attempt to port to Sloaris...
 * Work In Progress(WIPed)
 *
 * Revision 3.4  1994/05/31  14:25:39  green
 * suns don't like #include <sys/select.h> - ifdef'ed out
 *
 * Revision 3.3  1994/05/31  12:03:52  green
 * some OSes define MAXNAMELEN - some don't
 * handled with an ifndef in def.h
 *
 * removed "#include "h.h"" in defined.c
 *
 * yanked ANSI prototyping in dsh.c/dshd.c as some(sic) C compilers can't
 * swallow them
 *
 * #ifdef'ed fcntl(F_SETOWN) out for HPUX in dsh.c as HPUX doesn't define
 * it
 *
 * #ifdef'ed "#include <sys/select.h>" out of h.h #ifdefed
 * __hpux/bsd_4_2/SVR3/__osf__.(taken care of in types.h in most of
 * these.)
 *
 * Revision 3.2  1994/05/30  23:56:16  green
 * added necessary defs for DCMD/DSH to def.h
 *
 * added notes on necessary hooks to dqs_execd.c reqd for direct execing
 * of dsh
 *
 * added "#include <setjmp.h>" to h.h
 *
 * Revision 3.1  1994/05/28  15:43:07  green
 * added dqs_c_dshd.c to Makefile.proto
 *
 * misc type casting to squalk cc warnings
 *
 * Revision 3.0  1994/03/07  04:15:02  green
 * 3.0 freeze
 *
 * Revision 1.1.1.1  1994/02/01  17:57:49  green
 * DQS 3.0 ALPHA
 *
 *--------------------------------------------------*/

#include <setjmp.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <sys/signal.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <syslog.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <time.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/file.h>

#if defined(__hpux) && defined(__hppa)
#  define _KERNEL
#endif

#include <sys/resource.h>

#if defined(__hpux) && defined(__hppa)
#  undef _KERNEL
#endif 

#include <pwd.h>
#include <sys/socket.h>


#if ( defined(sun) || defined(solaris) || defined (SOLARIS23) || defined (SOLARIS24) || defined (SOLARIS25) || defined (SOLARIS26) || defined (SOLARIS27))
#include <dirent.h>
#ifndef RUSAGE_CHILDREN
/* why am I doing this - well SUN can't seem to decide whether to use
sys/rusage.h or not - they say it is "OBSOLETE" but don't have the
necessary defs anywhere else in Sloaris 2.3
 Solaris 2.4+ now uses /usr/include/sys/resource.h for load_average definitions.
*/
#if ( defined (SOLARIS24) || defined (SOLARIS25) )
#include </usr/ucbinclude/sys/rusage.h>
#else
#include <sys/rusage.h>
#endif
#endif

#else
#include <sys/dir.h>
#endif

#include <sys/stat.h>
#include <grp.h>
#include <stdlib.h>


#ifndef _UNICOS
#include <sys/file.h>
#else
#include <dirent.h>
#include <sys/category.h>
#include <sys/times.h>
#endif

#ifdef __hpux
#include <sys/times.h>
#endif

#ifdef _AIX
#include <sys/select.h>
#endif
/*patch*/
#if !(defined(__linux__) && defined (__GLIBC__) && __GLIBC__ >= 2)
#include <nlist.h>
#endif
#if ( defined(i386) || defined(__MACH__) ||  defined(sun) || defined(solaris) || defined (SOLARIS23) || defined (SOLARIS24) || defined (SOLARIS25) || defined(NeXT) )
/*   empty */
#else
#include <sys/sysinfo.h>
#include <unistd.h>
#endif

#ifndef NeXT
#include <unistd.h>
#endif











