static char qhold_rcsid[]="$Id: qhold.c,v 1.2 1998/10/26 19:24:09 green Exp $";

/*----------------------------------------------------
 * qhold.c Tom Green Fri Apr  1 13:46:13 EST 1994
 *
 * Copyright 1994
 *
 * SUPER COMPUTER COMPUTATIONS RESEARCH INSTITUTE
 *            FLORIDA STATE UNIVERSITY
 *
 *
 * SCRI representatives make no claims about the
 * suitability of this software for any purpose.
 * It is provided "as is" without express or
 * implied warranty.
 *
 * $Log: qhold.c,v $
 * Revision 1.2  1998/10/26 19:24:09  green
 * use the DQS_EXIT macro to determine exit value of ancillaries
 *
 * Revision 1.1.1.1  1998/08/18 14:39:14  green
 * DQS 3.2.0.5 WIP Import
 *
 * Revision 1.1.1.1  1997/04/10 15:10:35  green
 * DQS 3.1.3.4.1 Distribution
 *
 * Revision 3.6  1996/11/20 23:05:13  nrl
 * Several fixes submitted by or as a result of investigations by
 * Ron Lee, Bodo Bechenback, Guntram Wolski and Frank Dwyyer.
 *
 * Revision 3.5  1996/06/27  01:56:15  nrl
 * changes to accomodate osf gcc
 *
 * Revision 3.4  1996/03/26  00:03:24  nrl
 * changed hold/release to explicit use of hold types
 *
 * Revision 3.3  1994/06/12  03:45:29  green
 * mods to dqs_send_receive_list() necessitated for the support of
 * moving dshd into dqs_execd required propagation to all ancillaries.
 * (eg: return value of dqs_send_receive_list() was modified...)
 *
 * Revision 3.2  1994/05/27  22:39:59  green
 * ignore
 *
 * Revision 3.1  1994/04/20  23:25:57  green
 * added qhold.c qrls.c
 *
 *--------------------------------------------------*/

#define MAINPROGRAM
#include "h.h"
#include "def.h"
#include "dqs.h"
#include "struct.h"
#include "func.h"
#include "globals.h"
#include "dqs_errno.h"

/************************************************************************/

main(argc, argv,envp)
     int argc;
     char **argv;
     char **envp;
     
{
  
  int              sfd;
  char             c;
  char             *tp;
  int              tpi;
  int              holdval;
  string           str;
  FILE             *fp;
  dqs_list_type    *argv_list=(dqs_list_type *) NULL;
  dqs_list_type    *head=(dqs_list_type *) NULL;
  dqs_list_type    *resp=(dqs_list_type *) NULL;
  dqs_list_type    listel;
  dqs_list_type    *listel_ptr;
  dqs_list_type    *tmp_ptr=NULL;
  
  DENTER_MAIN((DQS_EVENT,"qhold"));   
  
  dqs_setup(QHOLD,argv[0]);
  dqs_setup_sig_handlers();     
  
  bzero((char *)&listel,sizeof(listel));
  
  argv_list=dqs_args2list(++argv,argc);
  listel.job=dqs_parse_job(argv_list,envp);
  
  if (listel.job->verify)
    {
      dqs_show_job(listel.job);
      exit(0);
    }
  holdval= listel.job->hold;
  
  if( (VALID(OTHER,holdval)) || (VALID(SYSTEM,holdval)) ||
      (VALID(USER, holdval ) )){
    if(VALID(NO_HOLD,holdval) ){
      fprintf(stderr,"illegal hold values, n cannot be combined\n");
      exit(-1);
    }
  }
  if(listel.job->hold==0) SETBIT(USER,listel.job->hold);
  listel.type=QHOLD;
  
  if (dqs_send_receive_list(me.default_cell,conf.qmaster_service,&listel,&resp)<0)
    {
      DEXITE;
      exit(DQS_EAGAIN);
    }
  
  dqs_show_acknak_list(resp);
  
  DEXIT;
  DQS_EXIT(resp->status);
  
} 











