static char queusage_c_rcsid[]="queusage.c,v 1.1.1.1 1994/06/18 19:43:32 kerce Exp";

/*-----------------------------------------------------------------------------
 * Kingsley Kerce
 *
 * Copyright (c) 1994
 *
 * Supercomputer Computations Research Institute (SCRI)
 * Florida State University
 *
 * SCRI representatives make no claims about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * queusage.c,v
 * Revision 1.1.1.1  1994/06/18  19:43:32  kerce
 * DQS X Distribution
 *
 *---------------------------------------------------------------------------*/

#include <assert.h>
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/AsciiText.h>
#include "h.h"
#include "def.h"
#include "struct.h"
#include "dqs.h"
#include "globals.h"
#include "help.h"
#include "queusage.h"
#include "xgui.h"

extern Display *XDisplay;
extern Widget TopLevelW;

static void
DQSQueueUsageTypeHelp (W, ParentW, CallData)
     Widget W;
     Widget ParentW;
     caddr_t CallData;
{
  DENTER ((DQS_EVENT, "DQSQueueUsageTypeHelp"));
  DEXIT;
}

static void
DQSQueueUsageTypeCancel (W, ParentW, CallData)
     Widget W;
     Widget ParentW;
     caddr_t CallData;
{
  DENTER ((DQS_EVENT, "DQSQueueUsageTypeCancel"));

  XtPopdown (ParentW);

  DEXIT;
}

void
DQSQueueUsageTypeCompleted (W, ParentW, CallData)
     Widget W;
     Widget ParentW;
     caddr_t CallData;
{
  DENTER ((DQS_EVENT, "DQSQueueUsageTypeCompleted"));
  DEXIT;
}

void
DQSQueueUsageTypeRunning (W, ParentW, CallData)
     Widget W;
     Widget ParentW;
     caddr_t CallData;
{
  DENTER ((DQS_EVENT, "DQSQueueUsageTypeRunning"));
  DEXIT;
}

void
DQSQueueUsageType (W, ClientData, CallData)
     Widget W;
     caddr_t ClientData;
     caddr_t CallData;
{
  static Widget DQSQueueUsageTypeParentW;
  static Widget DQSQueueUsageTypeFormW;
  static Widget DQSQueueUsageTypeTitleLabelW;
  static Widget DQSQueueUsageTypeCompletedButtonW;
  static Widget DQSQueueUsageTypeRunningButtonW;
  static Widget DQSQueueUsageTypeHelpButtonW;
  static Widget DQSQueueUsageTypeCancelButtonW; 
  static int DejaVu = 0;
  Arg wargs[10];
  unsigned int n;
  
  DENTER ((DQS_EVENT, "DQSQueueUsageType"));
  
  if (DejaVu == 0)
    {
      DQSQueueUsageTypeParentW =
	XtCreatePopupShell ("DQSQueueUsageTypeParent",
			    transientShellWidgetClass, W, NULL, ZERO);
      
      DQSQueueUsageTypeFormW =
	XtCreateManagedWidget ("DQSQueueUsageTypeForm", formWidgetClass,
			       DQSQueueUsageTypeParentW, NULL, ZERO);
      
      DQSQueueUsageTypeTitleLabelW =
	XtCreateManagedWidget ("DQSQueueUsageTypeTitle", labelWidgetClass,
			       DQSQueueUsageTypeFormW, NULL, ZERO);
      
      DQSQueueUsageTypeCompletedButtonW =
	XtCreateManagedWidget ("DQSQueueUsageTypeCompleted",
			       commandWidgetClass, DQSQueueUsageTypeFormW,
			       NULL, ZERO);
      XtAddCallback (DQSQueueUsageTypeCompletedButtonW, XtNcallback,
		     (XtCallbackProc) DQSQueueUsageTypeCompleted,
		     DQSQueueUsageTypeFormW);
      
      DQSQueueUsageTypeRunningButtonW =
	XtCreateManagedWidget ("DQSQueueUsageTypeRunning", commandWidgetClass,
			       DQSQueueUsageTypeFormW, NULL, ZERO);
      XtAddCallback (DQSQueueUsageTypeRunningButtonW, XtNcallback,
		     (XtCallbackProc) DQSQueueUsageTypeRunning,
		     DQSQueueUsageTypeFormW);
      
      DQSQueueUsageTypeHelpButtonW =
	XtCreateManagedWidget ("DQSQueueUsageTypeHelp", commandWidgetClass,
			       DQSQueueUsageTypeFormW, NULL, ZERO);
      XtAddCallback (DQSQueueUsageTypeHelpButtonW, XtNcallback,
		     (XtCallbackProc) DQSQueueUsageTypeHelp,
		     DQSQueueUsageTypeFormW);
      
      DQSQueueUsageTypeCancelButtonW =
	XtCreateManagedWidget ("DQSQueueUsageTypeCancel", commandWidgetClass,
			       DQSQueueUsageTypeFormW, NULL, ZERO);
      XtAddCallback (DQSQueueUsageTypeCancelButtonW, XtNcallback,
		     (XtCallbackProc) DQSQueueUsageTypeCancel,
		     DQSQueueUsageTypeParentW);
    }
  
  XtPopup (DQSQueueUsageTypeParentW, XtGrabNone);

  DEXIT;
}


/* Set Emacs C-mode style.
   Local Variables:
   c-style: GNU
   End:
 */
