/*
 * libnqs/debug/errnototcm.c
 * 
 * DESCRIPTION:
 *
 *	Convert a file access related errno code to its corresponding
 *	transaction code.
 *
 *	Original Author:
 *	-------
 *	Brent A. Kingsbury, Sterling Software Incorporated.
 *	April 27, 1986.
 */

#include <libnqs/license.h>
#include <libnqs/proto.h>
#include <errno.h>			/* Errno definitions */
#include <libnqs/transactcc.h>		/* NQS transaction completion codes */


/*** errnototcm
 *
 *
 *	long errnototcm():
 *	Convert errno code to transaction completion code.
 *
 *	Returns:
 *		The transaction code corresponding to the
 *		errno condition.
 */
long errnototcm (void)
{
	switch (errno) {
	case EACCES:
		return (TCML_EACCESS);
	case EFBIG:
		return (TCML_EFBIG);
	case EISDIR:
		return (TCML_EISDIR);
#if	BSD
	case ELOOP:
		return (TCML_ELOOP);
#endif
	case ENFILE:
		return (TCML_ENFILE);
	case ENOBUFS:
		return (TCML_ENOBUFS);
	case ENOENT:
		return (TCML_ENOENT);
	case ENOMEM:
		return (TCML_ENOMEM);
	case ENOSPC:
		return (TCML_ENOSPC);
	case ENOTDIR:
		return (TCML_ENOTDIR);
	case ENXIO:
		return (TCML_ENXIO);
	case EPERM:
		return (TCML_EPERM);
	case EPIPE:
		return (TCML_EPIPE);
	case EROFS:
		return (TCML_EROFS);
	case ETIMEDOUT:
		return (TCML_ETIMEDOUT);
	case ETXTBSY:
		return (TCML_ETXTBSY);
	}
	return (TCML_FATALABORT);
}
