#ifndef __SAL_ERROR_TYPES_HEADER
#define __SAL_ERROR_TYPES_HEADER

/*
 * libsal/error/all-systems/types.h
 * error-code handling support
 * 
 * Part of the System Abstraction Layer
 */

#if defined (IS_BSD4_4)
extern __const char *__const sys_errlist[];
#elif !defined (IS_LINUX)
extern char *sys_errlist[];
#endif

struct TAG_sal_error
{
  unsigned long ulErrorApi;
  unsigned long ulErrorCode;
  char * szFile;
  unsigned long ulLine;
  BOOLEAN boCaught;
};

typedef struct TAG_sal_error sal_error;

struct TAG_sal_error_table
{
  unsigned long ulErrorCode;
  /* what is this error? */
  unsigned long ulErrorType;
  /* how should we call sal_dprintf() to announce this error? */
  unsigned long ulErrorFacility;
  /* ** not yet supported ** bitmap mask to turn on/off certain errors/warnings */
  const char * szName;
  const char * szDesc;
};

typedef struct TAG_sal_error_table sal_error_table;

struct TAG_sal_error_api
{
  unsigned long ulErrorApi;
  /* unique ID for this class of error */
  const char * szDesc;
  /* string to say where this error came from */
  sal_error_table * pstErrorTable;
  /* pointer to the error table proper */
};

typedef struct TAG_sal_error_api sal_error_api;
  
#endif /* __SAL_ERROR_TYPES_HEADER */
