/*
 * nqsdaemon/nqs_scripts.c
 * Prologue/epilogue scripting support
 * 
 * ORIGINAL AUTHOR:
 * Stuart Herbert
 */

#include <libnqs/license.h>
#include <libnqs/proto.h>
#include <libnqs/nqsxvars.h>
#include <SETUP/General.h>

#include <libsal/license.h>
#include <libsal/proto.h>
#include <libsal/defines.h>

#include <stdlib.h>
#include <errno.h>

int nqs_RunPrologueScript(char * szQueueName)
{
  char szBuffer[MAX_PATHNAME];
  int  iResult;
  
  sprintf(szBuffer, "%s/nqs.prologue %s\n", NQS_LIBEXE, szQueueName);
  iResult = system(szBuffer);
  
  switch(iResult)
  {
   case -1:
   case 127:
    sal_dprintf(SAL_DEBUG_INFO, SAL_DEBUG_MSG_WARNING, "Unable to exec NQS prologue script '%s'\n%s\n", szBuffer, asciierrno());
    return 0;
   default:
    return iResult;
  }
}

int nqs_RunEpilogueScript(char * szQueueName)
{
  char szBuffer[MAX_PATHNAME];
  int  iResult;
  
  sprintf(szBuffer, "%s/nqs.epilogue %s\n", NQS_LIBEXE, szQueueName);
  iResult = system(szBuffer);
  
  switch(iResult)
  {
   case -1:
   case 127:
    sal_dprintf(SAL_DEBUG_INFO, SAL_DEBUG_MSG_WARNING, "Unable to exec NQS epilogue script '%s'\n%s\n", szBuffer, asciierrno());
    return 0;
   default:
    return iResult;
  }
}
