/*
 *	@(#)PackageInfo.java 1.3 98/11/25 10:35:00
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

public class PackageInfo {
    public PackageInfo() {
	ClassLoader classLoader = getClass().getClassLoader();

	pkgInfo(classLoader, "javax.vecmath", "Point3d");
	pkgInfo(classLoader, "javax.media.j3d", "SceneGraphObject");
	pkgInfo(classLoader, "com.sun.j3d.utils.universe", "SimpleUniverse");
	//pkgInfo(classLoader, "com.sun.j3d.loaders.vrml97", "VrmlLoader");
    }

    static void pkgInfo(ClassLoader classLoader,
			String pkgName,
			String className) {

	try {
	    classLoader.loadClass(pkgName + "." + className);

	    Package p = Package.getPackage(pkgName);
	    if (p == null) {
		System.out.println("WARNING: Package.getPackage(" +
				   pkgName +
				   ") is null");
	    }
	    else {
		System.out.println(p);
		System.out.println("Specification Title = " +
				   p.getSpecificationTitle());
		System.out.println("Specification Vendor = " +
				   p.getSpecificationVendor());
		System.out.println("Specification Version = " +
				   p.getSpecificationVersion());

		System.out.println("Implementation Vendor = " +
				   p.getImplementationVendor());
		System.out.println("Implementation Version = " +
				   p.getImplementationVersion());
	    }
	}
	catch (ClassNotFoundException e) {
	    System.out.println("Unable to load " + pkgName);
	}

	System.out.println();
    }

    public static void main(String[] args) {
	new PackageInfo();
    }
}
