/*
 *      @(#)BoltCG.java 1.1 98/11/19 21:16:32
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

import javax.media.j3d.*;
import javax.vecmath.*;

class BoltCG extends CompressedGeometry {

    BoltCG() {
	super(cgHeader, cgData) ;
    }

    private static final byte cgData[] = {
	16,    0, -121,   84,    1,   14,  -16,    2, 
        38,  104,    4,   58,  -48, -120,    5,  -64, 
        16,  -13, -126,   34,  111, -128,   67,  -80, 
         0,  -93, -127,    1, -112, -102,   46,   96, 
        16,   79,   -8,  103,    1,  -34,  107,  -34, 
        96,    7,    0,    4,   -1,  -84, -128,   18, 
        45,  -26,    0,  119,  -33,  -80,  104,   60, 
        30,  -13,    0,   56,    0,  123,   -8, -112, 
         1,  -39,  -49,   48,    2,    2,   29,    5, 
        99,   29,   87,   67,  -52,    0,  -17,   88, 
       -38,  -49,   77,   45,  -26,    0,  119,   74, 
       -80,  -88,   30,   80,  -13,    0,   59,   47, 
       -89, -117,  -83,  -83,   -7, -128,   28,  -55, 
        -1,  -25,  -83,   64,   60,  102,    0,  113, 
        59,   76,  -27,   51,   43, -103, -128,   29, 
       -96,  -46,  -10,  118,  103,  -68,  -64,    8, 
        -5,   34,  113,   -6,  -20, -127,   64,  -52, 
         0,  -22,  -28,    4,  -30,  -71,   61,  -26, 
         0,  119,  -69,   64, -115,  -42,  -11,   50, 
        22,   96,    7,   89,  -24,   11,   84,   45, 
       -21,   48,    3,  -68, -114,  -70,  114,  -59, 
       -65,   48,    2,   49,   77,   17,   31,   25, 
        54, -116,  -64,   14,   58,  -37,  -69,  -93, 
      -101,   87,   51,    0,   56,  -46,   88, -124, 
        82,  111,  121, -128,   28,   14,  105,  -43, 
        80,   55,   -8,  -73, -104,    1,  -33,   -2, 
      -105,  -95,   20,  123,  -52,    0,  -32,    0, 
       111,  -11,   96,    1,  100,   60,  -64,    8, 
        -3, -116, -104,  -10,  -77,  -90,   96,    7, 
         2,  -31,  112,  -67,  111,   48,    3,  -65, 
        93,  -50,  -63,  -10, -125, -104,    1,  -45, 
       104,  -87,  -52, -102,  104,  -52,    0, -124, 
       -48,   67,  120,   73,  -83, -125,   48,    3, 
      -106,  -71, -121,   22,   61,  115,   48,    3, 
       -72,  -75, -101,   80,   12,  -47, -104,    1, 
       -46,   82,   51, -111,   26,  -30,  -10,   96, 
         7,   94,  -31,   53,  -39,  -59,   15,   48, 
         3,  -98,   63,   14,   53,  -76,  -33, -104, 
         1,   23,   40, -126,  -65,  117,  -85,    6, 
        96,    7,   97,   -1,   42,   94,  -62,    6, 
        96,    7,   87,   96,   39,   21,  -51,  -93, 
        48,    3, -123,  -47,   38, -120,   86, -122, 
      -116,  -64,    8,  -93,  -12,   33,  -55,  -35, 
      -105,   51,    0,   56,    1,  -46,   -4,   34, 
      -120,   89, -128,   29,    3,  119,  -59,   51, 
       101,  -52,  -64,   14,  -30,  -42,  111,   64, 
        51,   62,   96,    7,   49,    7,   58,  -77, 
        59,   70,   96,    4,   69, -104,  -40,  -12, 
        50,  109,   -7, -128,   28,  -23,  -68, -100, 
       111,   54,  -96,  -26,    0,  116,  105,  -33, 
        18,  -12, -105,   51,    0,   56,   10,   27, 
        76,   35,   77,   25, -128,   16, -100,   55, 
       -87, -119, -118,   51,  -26,    0,  112,  -10, 
        24,   25,   47,   47,  -26,    0,  114, -111, 
        -3,  -98,  -93, -100,  115,    0,  -95,   19, 
       -18,  106,   30,   50, -121,   37,  -60,   46, 
       -13,  -65, -101,  104,   37,  -15,  -59,  113, 
        15, -114,   46,  -25,  118,  -41,   79,  114, 
       -60, -125,  -18,  120,   57,  -20,   63,  105, 
        28,  113,   34,   -8,  -76,   14,  -11,  -52, 
       -66,  -41,   40, -108,  -66,  -37,  -53,  -66, 
        91,  -55,    9,  -58,   37,   39, -119,  -43, 
        -4,   79,  -58,   94,  114,  -52,  -23,  -19, 
        97,   -1,   34,   59,   44,  -36,  115,   58, 
       -40,  -94,  -48, -120,   12,  122,    7,   43, 
      -104,  -98,  -43,  -13,   -7,  -57,  -78,   17, 
       -57,   49,  -83, -118,   45,    8, -128,  -57, 
       -96,  114,  -71, -117,  109,  119,  -62,   46, 
       123,  125,   92,  110,   96,  -40,  -66,  113, 
        42,  -20,  -29,  -25,   40, -110,   54,  -34, 
       100,   75,  -97,  -46,   77,  -58,   36, -115, 
      -113,   24,   24,  -23,  -38, -114,  114,  -36, 
        67,  110,  -78, -122,   72, -128,   56, -100, 
       119,   16, -103,   41,  -31,  118,  126, -125, 
         7,   35, -118,   38,   -7,   60,   94, -124, 
        58,   17,  -60,  -30,  -87, -107,   22,   16, 
        45,  -15,  -55,  115,    9,   74,   96,   49, 
       -60,   25,  -58,    7,   92,   66,   82,   25, 
       102,  -80,   82,  -81,  112,   55,   52,  -42, 
       -90,    7,   -4,   28,   -4,  115, -123,  -59, 
        22,   33, -106,  107,    5,   42,   -9,    3, 
       115,   77,  104,   96, -121,   65,   88,  -57, 
        85,  -36,   83,   90,  -71,   98, -113,  112, 
       -81,   97,  103,   51, -104,  -82,    7,  107, 
       -35,   12,  113,  -87,  -60,  -26,   11, -108, 
        14,  -21, -103,  -18,    3,  114,   17,    2, 
       -17,  -16,   58,  -12, -123,   21,  -36,   68, 
        64,  -71,   19,  -18,  106,   30,   50, -121, 
        37,  -60,   46,  -13,  -65, -101,  104,   37, 
       -15,  113,  113,   22,    9, -112,   21, -113, 
      -108,  -76,   99,  -53,  -47,  -74,   15,   62, 
       104,   65,   49,  -27,  -17,  -83,   53,   19, 
        95,  -82,   28,   98,  -11,  -43,   52,  -62, 
         5, -103, -114,   49,   98,  -57,  115,  116, 
       -71,   80,  -76,   17,  122,   65, -127,  109, 
       102,  -19,   26,    8,  -68,    0,   64,   70, 
      -112,   27,  -95, -100,   82,  -14, -118,  -49, 
        -2,  101,  -41,   14,   49,  122,  -22, -102, 
        97,    2,  -52,  -57,   24,  -79,   99,  -71, 
       -70,   92,  -81,   90,    8,   61,  -17,  -18, 
       -73,   56,   40,  124, -116,  -68,   34, -123, 
       -33,  123,   85,  -19,    4,   30,  101,   58, 
       -77, -101,   59,  -33,   34,   12,  126, -118, 
         0, -104,   10,  114,   58,  -14,   48,   -9, 
        77, -110,   40, -112,  121,   16,  122,   51, 
       -23,  -11,   79,   78,   92, -120,   49,   35, 
      -113,  -63,   78, -128,   50,   -9,   34,   15, 
        57,  -62,  -62,   86,   25,    7, -111,   21, 
       -68,   12,  112,  -38,  -90,  -13,  -55, -118, 
       -37,  -23,  -68,  -42,   59,  -94,  114,   98, 
       -80,    9,   -9,  -99, -124,  -41,   50,    9, 
        88,   53,   12,  -23,   73,  -56,  124,   24, 
       -83,  -26,  121, -113,   91,   38,  108, -126, 
        86,  -48,  -94,    6,  -12,  116,   28, -126, 
        80, -110, -119,  -48, -102, -118,   33,  -87, 
        43,   53,   24,   53,  -27,   61,  104,  -44, 
      -107, -113,  -14,   58,  103,  -80,  -61, -120, 
        10,  -62,   51,   91,   32, -126,  -51, -112, 
        74,  -38,   20,   64,  -34, -114, -125, -112, 
        74,   18,   81,   58,   19,   81,   67,   53, 
        37,  102,  112,  106,  -88,  -28,   32, -101, 
        50,  -80,   25,   78,    9,  -31,  -48,  -51, 
        72,   91,   -7,  -28,  -77,  -36,  -17,   38, 
        76,  -95,   95,   -9,   69,  -26,   75,  -87, 
       -77,   11,  124,  107, -108, -127,   20,  -55, 
      -123, -126,   41,   94, -118, -100,  -28,  100, 
       -62,   28,   44, -102,  -54, -114,   87,   45, 
        25,   48,  -73,  -66,  -44,   62,  -84, -111, 
       -52, -104,   91,   82,   18,  -29,   97,  -52, 
      -125,  -76,   44,  -77,  -64,  -42,   10,   41, 
         3,  -76,   45,  -96,  -37,   81,  -72, -107, 
       113,    8,   22,   72, -112, -107,   41,  114, 
        64,  -52,   11,   91,   -9,  -74,  107,   73, 
       100,   66,    5,  -99,  125,  -35,  -35,  -32, 
       -14,   33,    3,   28,  -39,  101,  126,  -57, 
       -93, -118,  112,  -10, -101,  121,   20,  -10, 
        86, -123,   56,   88,   50,  -45,  -50,   63, 
       -88,  -62,   12,   44,  126,   22,   53,    1, 
       -59, -111,    8,   22,  117,   -9,  119,  119, 
      -125,  -56, -124,   12,  115,  101, -107,   -5, 
        30, -128,   41,  -61,  -58, -117,  124,   57, 
        33,   71,   33,  -31,  -23,  -15,   52,   45, 
        92,   46, -118,  112,  -12,  -18,   97,   27, 
       108, -106, -119, -128,   99,   14, -126,  118, 
       -14,  -50,  -92,   60,   61,   68,  -19,  -89, 
       -44,   82,   96,   30, -102,  -33,   -8,   79, 
       107, -111,   48,   12,  119,   57,  -92, -112, 
        83,  -62,  -76,   76,    3,  -52,  -76,    1, 
        54,   19,   66,   38,    5,  -26,  -92, -105, 
        56,  -87,   45,   24,  -14,  -12,  109, -125, 
       -49, -102,   28,   76,  120,   35,  125,   31, 
        58,  -52,   92,  -73,  -84,  -64,   14,   -9, 
       -76,  -65,  -33,  102,   12,  -64,   14,  -52, 
        33,  110,  -58,  -42,   12,  -64,   14, -113, 
        -2,  -58, -117,    7,   28,  -64,    8,  -16, 
       -37,  -75,   19,   91,   81,  119,   48,    3, 
      -110,   39,  -13,   85,  -58, -121, -104,    1, 
       -41,   -4,  -17,  -35,   19,  121,  -52,    0, 
       -20,   97,   84,  -52,  123,   93,  -77,    0, 
        56,  -94,   59,  -70,  109,   33,  102,    0, 
        71,  -22,   53,  117,  -45,   23,  115,    0, 
        56,   12,  -27,   77,   22, -120,  121, -128, 
        29, -123,  -82,  -19,  -45, -121,  -84,  -64, 
        14,    1,  117,   73,    5,   21,  -52,  -64, 
         8,   38, -109,  103,   17,   51,    6,   96, 
         7,   74,  -28, -110,   72,   58,   22,   96, 
         7,   87,   49,  -69,   83,   77,  -97,   48, 
         3, -109, -106, -107,   84,  -75,  -37,   48, 
         3, -114, -123,   89,  -72,   75,  -50,   96, 
        20,  116,  -68,   49,   53,   70,  -92,  -72, 
      -123,  -45, -112,    2,  -58,  -20,  120,   92, 
        67,  -20,   68,    2,   78,   12, -108,  -79, 
        32,   -6,  114,    0,   80,  -35, -119, -104, 
      -111,  124,  -95,   23,    7,   11,  -75,   40, 
      -108,  -66, -100, -128,   20,   55,   98,  100, 
        74,   79,  111,   73,  116,  -44,    1,   75, 
        51,  -89,  -89,   32,    5, -115,  -40, -101, 
      -103,  -42,  -48, -126,   57,  -70,    1,   82, 
       -71, -117,  105,  -56,    1,   67,  117,  -89, 
        92,  -63,  -80,   44,  118,  -33,  123,  -44, 
       -94,   72,  -38,  114,    0,   80,  -35, -119, 
       -47,   36,  109,   30,   18,   32,   33,  -75, 
        45,  -60,   54, -100, -128,   20,   55,   98, 
       118,  -30,   19,   87,   62,  -37,   12,   81, 
        72,  -30, -119,  -89,   32,    5,   13,  -40, 
      -100,  113,   84,  -55,  126,  -86,   64,   29, 
        82,    9,   74,  105,  -56,    1,   99,  118, 
        60,    4,  -92,   54,  -17,  -16,   51,  -51, 
       -17,  105,  -83,   13,  -54,  121,   -1,  -88, 
        13,  -16,  -16, -102,  -43,  -38, -105,  -84, 
       -34,   25,  -87,   28,  -59,  116,  -28,    0, 
       -79,  -69,   19,   14,   96,  -70,  121,  -68, 
      -114,  101,   10,   66,   32,   93,   57,    0, 
        40,  110,  -60,  -63,   16,   46,   91,   -8, 
       -93, -120,  -14, -110,  -30,   23,   78,   64, 
        11,   27,  -79,  -59,  113,   26,   33,  111, 
       -19,   79,  -35,  -64,   87,   48,  102,  -18, 
       127,   42,   66,  -76,   61,   24,   49,  115, 
       124,  -99,   44,  122,   43,  -38,  -15,  115, 
        -5, -104,  -80, -113,  -34,  -19,  122,  -72, 
        59,  112,   49,    3,  -43,  -95,  -26,   68, 
       -85, -100,  111,  -70,  127, -101,   72, -111, 
        40,  -26,    1,  -69,   62,   91,   43,  114, 
       116,  119,   87,  -15,  -81,  110,  -46,  121, 
        58, -104,  -40,   78,  -80,  102,   42,  -40, 
        29,   77,  -20,    9,  111,  -31,   23, -116, 
        14,  -90, -102,  -63,   71,   13, -107,  -26, 
         5,  -87, -100,  -60,   81,   63,  -22,   73, 
      -127,  102,  111,  -81,  -16,    4, -103,  -85, 
       -34,  -45,   52,  -16,  107,  -80,  -57,   82, 
       111,  105, -102,  -77,  -63,   80,  -36,  108, 
      -124,  -76,  -52,   22, -103,   80,  -41,  -23, 
         4,  -76,   77,  -93,  -47, -128,    4,  -90, 
        64,   58,   38,   53,   72,  -52, -108,  -12, 
      -128,   58, -122,   18,  -25,   13,  -44,   59, 
        32, -118,   67,   38,    1,  119,   85, -101, 
        24, -118,   71,   83,  -12,   46,  -92,   -5, 
       -48, -111,   71,   68,  127,  108,  -87,  -46, 
        48, -111,   55,   85,   -7,  -23,  -66, -127, 
      -112,   92,   27, -120,   -3,   83,   33,   53, 
        24,   92,   27,  -84,   32,  -37,   95,  122, 
       -82,   96,  -51,  -36,   -2,   84, -123,  104, 
       114,   48,   98, -113, -109,   49,  -64,   67, 
       -69,  -39,   87,   16,  -70,  -17,    0,   32, 
      -107,  -48,   87,   16,   -8,   64,   15,    4, 
        89,  -17,  120, -112,  125,  -19,  -32,    0, 
         8,    4,  -80, -125, -119,   23,  -58,  -60, 
       120,  -29,  -37,  101, -119,   75,  -21,  -64, 
         0, -126,   87,   66, -119,   73,  -18,  -45, 
       -86,  -72, -121,  -67,  -26,  116,   -9,  -73, 
      -128,    0,   32,   18,  -61,  -42,  103,   79, 
        36,   40,   41,  -10,   74,  -34,  102,   91, 
       111,   90,   -3,   21,   29, -118,  -26,   45, 
      -111,   15,   -2,  -10,  -91,  -26,  -26,   13, 
       -75,  -75,  113,  104,  -84,   98, -119,   35, 
       100,   67,   -1,  -67,  -88,   95, -119,   35, 
        97,   89,  -60,  111,   31,  -79,  110,   33, 
       -78,   35,   -1,  -50,  -44,  -73,  -18,   33, 
        55,  117,   -4, -102,   66,  124,  -60,  113, 
        68,  -56, -121,   -1,  123,   80,  -14,  113, 
        84,  -36, -119,  125,   22,    6,   49,    4, 
       -91,   50,   35,   -1,  -50,  -44,  -82,    4, 
       -92,   55,  -38,  112,  -45, -116,   88, -109, 
        90,   25,    7,    5,   31,   97,   89,   83, 
        90,   26,   -7,   -6,  -24,  -98,  -40, -109, 
        90,   25,   16,   -1,  -25,  106,   89,   83, 
        90,   26,  -16,    0,   32, -107,  -38,   19, 
        90,  -70,   30,  111,   -5,   -5, -113,  101, 
        57, -118,  -21,  -64,    0,   98,   88,   66, 
        57, -126,  -30,   92,  -63,  -75,  -83,   61, 
      -120, -127,  119,  -73, -128,    0,   32,   18, 
       -62,    8, -120,   23,   44,   52,  -71, -108, 
        57, -107,  113,   11,  -82,  -16,    2,    9, 
        93,  -19,  113,   44,   51,  -33,  -43,  -98, 
        -6,   41,  -40,  -18,   98,  -38,   51,   -1, 
       -41,   21,   85,  -18,   98,  -40,   33,  111, 
       -65,  -69,  -51,   87,   49,  108,    7,  -32, 
        66,   -4,    7,   58,  -36,  -59,  -73, -110, 
       -22,  -25,  -44,   46,   98,  -64, -121,  112, 
         0,   45,  107,   -9,   49,  109, -102,   72, 
        44,  110, -124,  123, -104,  -74,   76,  -37, 
       -33,  -85,   98,   69,  -52,   91,  123,   -1, 
        -7,  -19,  121,  -54,  -26,   44,   33, -123, 
        -7,   89,  -28,  -22,  123,  -71, -117,  109, 
        -9, -127,   33, -128,  -13,  102,  -85, -104, 
       -74,    5,  -67,  -17,   92,   91,   23,  -18, 
        98,  -37, -112, -125,  -40,  -56,   43,   23, 
        49,   97,  -51,   72,   80,  -89,   87,  -69, 
      -104,  -74,    0,  -42,    0,    0,   -1,  -55, 
        70,  -71, -117,  107,  -51,  -32,   91,   17, 
       -80,   92,  -59,  -74,   80,  -10,   98,  124, 
       -85,  -36,  -59, -123,  124,   25, -127,   57, 
        18,   46,   98,  -38,   51,   -1,  -49,  114, 
      -114,  -73,   49,  109, -120, -101,   -8, -122, 
      -117, -104,  -72,   52,   88,    1,    2,  -21, 
       -43,  -30,   82,   -8,   34,    0,   56, -108, 
        40,  -47,   41,  124,  -51,   58,  -54,   -1, 
        21,   40, -108,  -66, -128,   98,  -88,  -99, 
       -37,   76,   74,   95,   79,  -15,  -42,   43, 
        -8,  -17,   49,   41,  124,   86,  -79,  -13, 
       125,   18,  -20,   74,   95,   29,   28,   39, 
       -92,   41, -126,   37,   47, -112,   24,  -92, 
       -79,   -7,  -98,   37,   47,  -81,   22,  -73, 
       -46, -123, -126,   37,   47, -116,   -7,  -20, 
       -87,   81,  -94,   37,   10,   59,  119,  -75, 
        99,   17,  -91,  -59,  -60,   46, -104,  121, 
        97,  113,  -70,   82,  -30,   23,   64,  -61, 
        74,   56,  117,   21,  113,   11,  -92,   94, 
        82,   83,   42, -122,  -72, -123,  -63,   16, 
       -62,  -48,   70,  109,   92,   66, -121,   32, 
       -13,   87, -108,  -67, -115,  113,   11,  -93, 
        63,   -3,  113,   81,  105,  113,   11, -114, 
       -31,  -79,   45,   10, -100,  -72, -123,  -41, 
      -113,   37,  -28,  -38,  116,   92,   66,  -32, 
       -72, -106,  -42,  -88,  -82,   33,   65,  -60, 
        49,  -26,   94,   83, -105,   16,  -69,   31, 
       -25,   20,  -48,  -24,   43, -120,   92, -106, 
        12,   49,   18,  -76,   53,  -60,   40,    8, 
      -122,   22, -126,   51,  -94,  -30,   23,   47, 
         4,  -90,   13,   93,  113,   11, -126,   32, 
         3, -119,   68, -112,  -72, -107,   30,   -1, 
        -2,  123,   94,   95,   57, -118,  -20,  -62, 
        66,    3,  111,  -85, -100,  -59,  113,  -26, 
       -33,  127,  112,  -42,   14,   98,  -70, -114, 
      -124,   17,   64,   47,   71,   49,   92,    5, 
      -111,   23,  -92,  -19,   71,   49,   80,  116, 
       -24,  -98,  -63,  -30,   43, -100,  -59,  112, 
        68,    0,  113,   40,  -47,  -50,   98,  -72, 
        97,  111,  126,  -80,  -22,   39,   49,   93, 
       -99,   72,   92,  -30,   71,  -77, -104,  -82, 
        -1, -120,   -2,  110,   -1, -120,  114,   57, 
      -118, -124,   -8,    1,   74,  -51, -128, -105, 
      -114,   98,  -71,  119,  124,   55,   84,  -83, 
        71,   49,   92,    4,   31,   -3,  123,  -41, 
       -74, -100,  -59,  119,  -32,  126,  121,   15, 
      -120,  -12,  115,   21,    0,   89,   17,  122, 
        78,  -24,  115,   21,  -62,  -23,  -69,   93, 
        99,   57, -118,  -24,  -49,   -1,   92,   84, 
       111,   57, -118,    5,   36,   72,   64,   65, 
      -123,  -88,   37,   41, -128, -117,   -1,  -97, 
       123,   38,  -48, -108,  -90,  -85,  -63,  -40, 
       -65,   56,   90, -126,   82, -103,   43,  121, 
        65, -126,   43,  123,    9,   74,  109,  -91, 
        33,  -61,   79,   21,  102,  -96, -108,  -90, 
        21,   78,   11,   97,   58,   25,  -62,   82, 
      -126,  -65,  114, -116,   -6, -101,   66,   82, 
      -101,   -5,   64,  -86,    7,   46,  106,    9, 
        74,   97,   35,  -30,  122,   16,  -59,  -20, 
        37,   41, -128,   12,  127,  -57, -128,   45, 
       -39,  -62,   82, -126,  -65,  114, -116,   -6, 
       -99,    2,   82, -104,   30,  -93,  -36,   13, 
       -95,   41,   77,   -5,  -64,    3,   68,   39, 
        52, -124,  -95, -125,   83,   -7,   71,  -90, 
        34,  -81,  -72, -122,  -63,   16,    1,  -60, 
       -93,  120,  -36,   67,  106,   78,   13,   65, 
       -58,  -37,  119,   16,  -37,   76,  126,   91, 
       117,  117,  106,  -36,   67,  105,  -99,   13, 
        62,  113,   77,  -73,  113,   13, -103,  -21, 
       -51,   94,   85,  -89,  -67,  -60,   54,    9, 
       100,    6,   98,   34,  -12,  121,  -36,   67, 
       108, -103,  -14,  -83,  -57,   16,   -9,   16, 
       -40,   34,   24,   98,    8,  -51,   -5, -120, 
        32,   90, -103, -119,  109,  -92,  -81,  -90, 
         0,  -74,  -42,   -2,   95,  -68,   80,   83, 
         0,   89,  100,  -23,   49,   72,  107,  -55, 
      -128,   45,  105, -124,  111,   98, -106,    4, 
       -64,   22,   90,  -86,   98,   88,  -90, -124, 
       -64,   16,   18,  -43,   54, -127,   19,   91, 
       -45,    0,   91,  -76,  -21,   38,  123,  -77, 
       123,   76,    1,   96,   70,   34,  -11,  -31, 
        10,  -58,    4,  -64,   22,  -33,  126,   26, 
       -40,   38,  -12,  -64,   16, -126,   26,   50, 
       -72,  116, -104,   19,    0,   90,  -47,  -66, 
        26,  -68,   30,  -45,    0,   88,   20,   56, 
       -38,  -96,   76,   -7,  -67,   48,    5,  -69, 
       -42,   61,    7,  -60,  -42,    4,  -64,   22, 
       -23,   14,   54,  -32, -106,  -12,  -64,   16, 
       -42,  118,   40,  -67,  106, -102,   19,    0, 
        88,  -90,  103,   93, -118,   86,  123,   76, 
         1,   96,   11,  -30, -124,   64,   42,   70, 
         4,  -64,   22,  103,  -94,  122,  101,  117, 
       -28,  -64,   16,  -46,   76,   -1,  -72,   43, 
         2,   96,   11,   62,  -21, -101,   60,   99, 
         2,   96,   11,   12,  -83,  -26,   11,  123, 
       -94,   96,   11,    2,  -29,   80,  -67,  -19, 
        48,   20,   62,   64, -121,  -89,   55,  119, 
        29,  -51,   73,   91,   64,  -33,   48, -111, 
        61,   26, -110,  -79,  -28,   28, -101,  -55, 
        51,   27,   34,  -73,  -37,  126,  127,   47, 
        57,   27,   34, -127,   44,  -93,  121,   35, 
       109,   76,    6,  -56,   45,  -85,  -37,   -3, 
       -97,   79,    3,  -76,  -84,   11,  -56, -115, 
       -46,  -93,  -95,  -78,   43,   47,   68,  -90, 
         9,  124,  -39, -124,   16,   -9,   78,   19, 
       -84,  -10,   59,   66,  -64,   79,   64,   85, 
       -96,   85,   44,  -29,  -76,  -83,  127,  -70, 
       -34,  112,   45,    6,  -52,   32,    4,  -73, 
       -10,   72,   22,  -69,    8,   32,  -75, -122, 
        18,  103,   71,  102,   16,   65,   99,  113, 
       -77,  -78,   98,   97,   29,  -95,  110,  114, 
       126,  -82,   22,  102,   16,   97,  107,  121, 
       -41,   20, -109,   66,   29,  -95,    5,   85, 
       -10,  -59,  122,  -69, -120,   32,  -78,  122, 
       -19,  -88,  -71,   96,   16,   65,  -23,    6, 
        21, -127,  -20,  103,   20,  -31,  103,   41, 
       -79,   62,   67,   96,   16,   33,  -24,  -38, 
        78,  -31,  -67,  123,   20,  -31,  -17,  -43, 
       -96,   22,  -17,  -54,   87,  -79,   78,   30, 
         2,  -90,   -2, -110,    3,   91,  102,   20, 
       -31,  -19, -114,  -70,  117,   25,   97,   33, 
       -31,  -31,  -11,   19,  106,   90,  102,   20, 
       -31,  -18,   14,  -20,  -75,  -90,  118,   33, 
       -31,  -23,  -85,   54,   41,   80,  -18,   67, 
       -61,   12,  -83, -109,  -19,   97, -100, -121, 
      -105, -123,  -52,  114,  -57,  -35,   16,  -57, 
      -121, -113,   32,  102,   37,   98,  -24,   67, 
       -61,  -62,  -23,  -69,   93,   91,   33,  -27, 
      -118,  -56,   24,  -42,   -7,   59,   24,  -14, 
       -15,  -41,  -66,  -96,   69,   67,   49,  -31, 
       -26, -128,  106,    8,  -28,  -73, -112,  -14, 
       -63,  -85,    2,  126,  -68,  -50,  -10,  113, 
        11,  -64,   83,   31,    3,  -33, -128,   72, 
         7,   16,  -67,  107,   24,  -87,   56, -107, 
       -13,   30,   94, -106,  -15,   29,  107,   98, 
         9,  -59,   47,   42, -125,   92,   75,  101, 
       -28,  -57, -106,   57,  127,  -34,  -42,   25, 
       123,   56, -123,  -17,  -42, -128,  126,   32, 
        63,  -26,  115, -120,   94, -125,   75,   29, 
        24,  -89,  -67,    4,   94,   -1,   34,    2, 
       -81,    3, -122,  118,  -48,   69,  -31,   61, 
       -45,   54,  -34,  -49,  -96,  -61,  -49,  -61, 
        13,  -66,   14,  -63,  -47,   67,  -55,  -49, 
        -4,  109,   74,  -49,  -55,    3,  -43,   96, 
       115, -111,  -34,  -27,  -55,    3,    0,    0, 
        -4,  -10,  123,  -93,   32,  114,   66,  -79, 
        45,    1,  -80,   67,  -48,   57,   48,  122, 
        19,  112,  -66,  -64,   78, -100, -112,   60, 
        14,   82,   46,   21,   -2,   70,   80,  116, 
       -95,   66,   88,  -21,  -73,   38,   43,   11, 
        17,  106,  -68,  -76,   14,   76,   30,   51, 
        91,  -21,  -56,  -62,    7,   35,   40,   84, 
        29,  -84,   81,   69,  -39,   16,   21, -112, 
       -13,   92,   80, -118,  -22,   32,   43,   94, 
       -20,   61,  -14,  -19,   11, -109,   21, -115, 
       -55,  -68, -125,   48,  -67, -120,   10,  -60, 
        59,  124,  122,   51,   65,  -28,  -59,   14, 
       -94,   75,   35,  -67,   59,  -94,    2,  -75, 
       -30, -108, -123,  -17,   97,   68,    5,   98, 
       -47,   56, -117,   61,  119,   53,   37,  109, 
         3,  124,  -62,   68,  -20,  106,   74,  -59, 
        -3,    6,  -69,  120,    4,  -44, -128,   -4, 
         0,    0,    0,    0,   10,   64,    0,   32
    } ;

    private static final CompressedGeometryHeader cgHeader ;

    static {
	cgHeader = new CompressedGeometryHeader() ;
	cgHeader.majorVersionNumber = 1 ;
	cgHeader.minorVersionNumber = 0 ;
	cgHeader.minorMinorVersionNumber = 0 ;
	cgHeader.bufferType = CompressedGeometryHeader.TRIANGLE_BUFFER ;
	cgHeader.bufferDataPresent = CompressedGeometryHeader.NORMAL_IN_BUFFER ;
	cgHeader.start = 0 ;
	cgHeader.size = cgData.length ;
    }
}
