/*
 *      @(#)GullCG.java 1.1 98/11/19 21:15:25
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

import javax.media.j3d.*;
import javax.vecmath.*;

class GullCG extends CompressedGeometry {

    GullCG() {
	super(cgHeader, cgData) ;
    }

    private static final byte cgData[] = {
       25,    0, -128,   16,   -6,  -56,   32,   54, 
       16,   64,  -18,   32, -128,   94,   65,   15, 
      -64, -126, -113,    5,    5,   10,   32,   10, 
       44,   32,   20,  120, -128,   40,  -71, -128, 
       80,  -44,    0,  -95, -118,    1,   67, -104, 
        2, -113,  -72,    4, -124,  104,    9,    7, 
       72, -113,    8,   49,   65,  -52,  -61,   30, 
        5,   45,   88,   20,   -5, -107, -127, -108, 
      -65,  -31,  -42,  -17,   33,   29,  -87,   56, 
      -48, -121,   -2,   88,   27,   18,  -61,  109, 
      -17,  -78,  -24,  -72,  -87,   31,  -84,    6, 
      104,   92,  -91, -109, -112,    2,   31,   93, 
     -105,  -79,   34,   96,  -94,  115,  -75,   53, 
        1, -124,  -12,   49, -106,    4, -112,  -53, 
      124, -109,   87,   69,  -54, -114,  112,    4, 
        1,    3,   62,  121,   53,   -1,   73,  -82, 
      -71,  -53,   96,    4,    1,   74,  -22,  -62, 
      -55,   16,   45,    2,  -50,   85,  -39,   46, 
      -16,   -4,   22,   91,   94,  -80,  111,  121, 
      -38,  -17,   57,  108,   53,  102,   64,   99, 
     -112, -128,    0,    0,    1, -112,   40,   45, 
       98,  101,  -51,   53,  -81,  -75,  -38,    0, 
      -50,   -6, -128,  -29,  127,   43,   -6,  -19, 
     -106,  -29,   -8,    2,    6,    0,   19, -112, 
       17, -128,   80, -110,   72,   64,   53,   -5, 
      -21,  -89,  -78,  -36,    1,    0,   64, -128, 
        2,   25,    1,  -35,   64,    2,   21,   50, 
       50,   66,    0, -121,  -32,   93,  115, -106, 
     -113,  -15,  125,  -60,   37, -122,  -71,    0, 
       33,  -11,  -39,  118,   26,  -63,   68,  -25, 
       92,  -68,   -6,  -76,   -9,   66,   25,  -72, 
       67,  -80, -105,  -27,  120,  -70,  -23,  -77, 
       69,  -12,  -64,  -75,    5,   80, -123,   39, 
     -122,  -89,  -22,   93,  101,   47,  -56,  -41, 
       -6,  -11,   72,   65,   85,  -98,  -89,  -39, 
     -125,   69,  -43,  -82, -102,  -48,    1,  -11, 
       23,  112,   17,  -63,   67,  127,  -77,   96, 
       -9,   70,   73,   16,  -43,  -59, -107,  -65, 
       18,   95, -103,  125,  113,   18,   55,   -3, 
      -72,    1,   46,  123,    0,   78,   88,    0, 
      126,    5,   -9,  -16,   63,  -98,    8,  -96, 
       22,  -62,  103,  -97,   78,  122,  105,   67, 
      -88,   12,   33,  -65,  -45,   -3,   33,  -24, 
      -74, -128,   -9,  127,  122,  -63,   16,  -49, 
       26,   91,   -6,   22,  -13,   45,   23, -109, 
       -8,  -52,   20, -116,  116,   25,  -74,   33, 
       53,  -21,  -49,  125,   63,  -44,  -21,  -67, 
       83, -127,  -97,  -28,   66,  -22,   69,   42, 
       -8,  -64,  -55,  114, -116,  -38,  -64,  110, 
       27,  -48,   -5, -123, -102,   -8,   63,   85, 
        8, -127,   -3,  -27,  -65,   55,  -11,   52, 
       36,   38,  -64,   68,   38,  -39,   38,  125, 
      -97,   74,  -81, -125,  110,  -61, -116, -106, 
      -70,   89,   54,  -64,   68,   21,  -95,    2, 
      -53,   21,   -2,  -67,  -62,  -32,   -4,  109, 
       48,   63,    5,  111,  -85,  -95,    5,   63, 
      -56,  -79,  -44,   46,  114,   80,   13, -106, 
     -119,   95,  127,    3,   -7,  -32, -118,    1, 
      107, -122,  121,   -2,  -49,  -69,    1,   70, 
       13,  -68,   -1,   91, -120,    2,   31, -108, 
       -3,   32,   18,   97,   85,  119,   27,   96, 
      -57,  127,   64,   62, -127,  -67,  -36,  104, 
       39,   27,  -56,   73,   12,  -52,   10,   -2, 
       68,   34,   27,  -49,   -2,   39,   25,   95, 
      -84, -115,  -74,    3, -125,   89,   13, -123, 
       -7,  113,  -34, -101,  -77,   47,   -5,  -61, 
       45,   -1,   69,   10,  -19,  -96,  -87,  120, 
     -107,   13,  -82,    8,   39,  101, -105,  -91, 
        5,   82,  -32,  -70,   77,  103,   36,  -16, 
       72,   22,  -53,  -37, -114,  -47,   16, -124, 
      -92,    7,   48,  113,  -12,   30,  -38,   68, 
       50,   -3,  126,  -96,  -94,  -54, -117,   32, 
      -60,  -44,   -7,  -83,   62,   63,   14,   -7, 
      102,  -55,  -72, -112,   -6, -124,  107,   23, 
     -101,  -54,   -3,  120,   17,  -36,    7,   31, 
       66, -122,   14,  -97,   87,  114,   26,   82, 
        6,   15,  -75, -112,  -39,  -69,  -18,  -70, 
       66,   51,  -50,  -66,  -62,    9,    8,  -73, 
       98,   -2,   43, -124,   54,   33,   63,   -2, 
       32,   16,  -44,  -12,  -17,  -44, -128, -106, 
      115,  -43,   -1,  106,   29,  -41,   98,  -63, 
       96,   14,   59, -114,  -72, -115,  -75,  -52, 
      -95,  -17,   57,  -58, -126,  -48,   50,  -72, 
       91,  -74,  -19,   94,  -75,   15,  -24,   97, 
     -128,  -24,   16,   92,   53,  -92,  -24,  -34, 
      -91,   13,   12,    0,    2,    0,   46,  -55, 
      118,  122,  -41,   66,   66,  -77,  -42,    4, 
       27,    1,  -11,  -45,  -19,   31,  119,  -12, 
       72,   95,   25,  110,  -76,   18,   -1,  117, 
       -2,   95,  -77,   -5,   60, -119,  116, -105, 
      -64,  127,   64,   43,  106,  -66,   48, -128, 
       22,   27,   13,  -70,  -19,  -36,  -68,  104, 
       99,   97,  -68,  -67,    1,  -10,  -49,   46, 
      107,   20,  -41,   75,  112,  -30,  -91,   24, 
     -104,  -99,   44, -108,  -50, -112,  -34, -116, 
       13,   64,  127,   45,  -60,    1,  115,  -54, 
      124,  -41,  120,  -16,  108,  -62,  -27,   57, 
      102,  110,    8,   67,   13,   -3,   42,   17, 
       64,  -39,  118,   -5,  -81,  -64,   -2, -128, 
       86,  -69,  121,  101,   -1,  112,   10,   55, 
       19,   38,   61, -114,  -77,   66,  -61,  -31, 
       98,   96,   55,   67,   65,   28,  -75,  -17, 
      -95,  -17,  -51,   10,  -46,  -27,    7,   -3, 
       45, -103,  121, -122, -103,   58,  -43,  -43, 
       12,  -70,  -16,    0,   18, -105,   32,   71, 
       61,    0,    1,  -31,  -16,    5,   82,  103, 
      -31,   95,    9,   52,  125,  -42,  -58,   46, 
      -80,   72,   84,  -41,  116,   29,  -66,   42, 
       81, -119, -113,  -75,   84,   35,   84,   72, 
      -66,   53, -112,  -42,    0,   -5,  -44,  110, 
       67,    0,  -93,   20,   17,  -82,  126,   28, 
       -6,  -53,   17,  117,   -2,  -93,  -93,   40, 
      -14,  -80,  -80,   65,   99,  122,  -34,   41, 
       95, -105,   41,   39,  -48,    3,  -63,  116, 
        1, -106,  -93,  -54,    8,  -49, -121,   -7, 
      -10,  118,  -11,  -71,  -43, -106,   34,   20, 
      -67,   71,   70,   88,  -25,   27,   56,  104, 
       -8,   39,  -25,   63,    7,   99, -101,   36, 
     -112,   78,   -7, -114, -108,  127,  -59,  -13, 
     -128,  -47,  -13,  -88,  -48,  -45,   81,  -34, 
      -26,  -34,  107,   40,   -5,   70,  122,  -81, 
      -13, -104,   50,   87,   59,   51,   25,  -40, 
       47,   14, -113,  -94,   82,  115,   79,   -3, 
      -95,  -82,    1,   44,   12,    0,  120, -124, 
       32,   17,   68,   64,    7,  -74,   97, -128, 
       92,  105,   16, -122,   45,  105,  126, -105, 
       28,  -62,  -69, -114,  -78,  -53,  -63,   32, 
       20,   93,   39,  -68,  -89,   -9, -128,  -44, 
       55,  102,  120,  -81,  -36,   13,  -41,   86, 
       91,  103,   63,  -89,   -4,   87,   22,  -35, 
       47,  -17,   96,  101,   -8,  -59,   42,  -76, 
       87,  -95,   26,  -70, -126,  116,   17,  -80, 
     -104,   11,   16,  -87, -115, -110,  -17,  -99, 
     -127,  117, -123,   -1,   49,   96, -128,    8, 
      -82, -103,    4,  -16,  -33,  -42,    7,   27, 
      -56,  105,    1, -111,  -99,  -54,  113,   20, 
       58, -127,   18, -114,  -66,   74,  -34,  -63, 
       48,   45,  -55,   76,    2,  -14,   19, -124, 
      109,  117,   83,    0,  -83,  -17,  -41,   -6, 
       92, -107,    0,  -81,    3,   51,    7,   21, 
      -55,  117, -127,  -11,  -65,   73,  -57,  -53, 
        0,   92,    6,  -11,  -58,   47,   90,   47, 
       19,   -9,  -41,  -72,  -78,  -30,  -48,    8, 
      -95, -126,   66,   22,   33,    1,   11,  -16, 
     -124,  -39,  -23,   47,   94, -104,    6, -124, 
       34,    5,  -40,   10,  -20,  -48,   17,  -29, 
        3,    8,  103,   96,   -8,   70, -103,  -16, 
       68,   42, -112,   36, -107,   -5,  -81,   40, 
      -70, -110,   60,  103,  -27,   13,   11,  -72, 
       11,  -98,   -2,   63,  -20,  -64,   94,   33, 
       48,   31, -128,   26,   47,   64,   35,  104, 
        0,  115,    5,  -72,    5,   64, -126,  -23, 
      124,   39,   27,   73,   22,   35,   11,  -65, 
       -4,  -11,  -96,  120,    2,  -80,   95,  -12, 
      -63,   56,   94,  -63,  124,  -18,   21,  113, 
     -101, -125,   84,   95,  107,   20,  -85, -127, 
      -73,   88,   54,   -4,   18,    6,  -21,  -37, 
      -15,   17,   10, -124,  -12,   32,   -4,   20, 
       60,  -76,  -71,  -54,    9,  -10, -126,   69, 
     -107,  -23,  -63, -127,  -88,   19,   90,   67, 
      -67,  -99,  -14,  -51,  107,  -15,   33,  -11, 
        7,  -34,   44,  -41, -123,  -10,  -68,   23, 
       17,    2,  -81,  -78,   67,    6,  -73,  -85, 
      -69,  -99,   42,   -4,    6,   90,   -2,   54, 
     -111,   -5,   46,  -67,   70,    6,   55,  -40, 
       65,  123, -118, -119,   -1,  -20,  -72,  -95, 
      -77,  -11,  -65,  -63,    0,   -2,  -92,   88, 
       -2,  -92,   10, -106,  114,   42,  127,  106, 
       27,   -9,   98,  -98,  -76,   23,   59,  -18, 
      -72, -102,   67,  -61,  -95,  -32,  -99,  -58, 
      126,   16,   86,  -72, -105,  109,  -60,   79, 
     -101,   67,  -75,   -8,  111,  -30,    9,   87, 
       53,    6, -112,   86,  121,   68,   33,   84, 
      111,  -64,  112,   25,  118,   68,  -37,   66, 
      117, -107,   33,   45,  -85,    3,   -9, -127, 
      -38,  -22,   50,  -47, -121,   95,   12, -123, 
       79,  -53,   62,    6,   64,  -30,  -20,   83, 
       45,  -56,   23,   -3,  -21,  -95,  -99,  -27, 
      127,  -81,  -56,  -95,  120,   75,  -54, -122, 
       32,  106,  -70,   94, -119,   57,   80,    1, 
       -5,  -41,  107,  -60,   42,  101,  -28,  -66, 
      -61,  125,   64,   81,  -18,  110,   23,   87, 
       65,   54,  -57, -122, -128,   39,  -43,   72, 
      102, -105, -111,  124,   85,   33,   86,    1, 
      -11,  -75,   72,   95, -108,   98,   -9,  -47, 
     -111,   -2,   31,   98,  -44, -120,  106,   82, 
      -84,  103,    0,   33,    9,  -77,  -27,   32, 
       76,   56,    0,  125,   53,  115,  -48,    8, 
      -64,    6,  -80,  104,   -7,  112,    3, -101, 
       52,  -70,  -46,   19,  -24,  111,  -18,   -4, 
       42,  -13,  117,   78,   52,   44, -126,  118, 
       18,  -37,  -67,    3,  -79,  -10,   79,   71, 
      -43,    0,  124,   52,   36,  -53,   -9,  -92, 
       38, -120,   -9,  -65,  -50, -123,   88, -103, 
       39,  -11,    0, -115,  -61, -127,  101,   42, 
      120, -111,    9, -124,   94,  -84,    0,    1, 
       22,   10,  -12,  118, -128, -104,  116,   -5, 
       18,  -70,   80,  -61,  -86,   17,  114,  -49, 
       -2,  112,   56,  -65,   20,  -65,  124,   35, 
     -126,  -14,  -19,  103,  -97,   -3,  -17, -118, 
      -18,   34,  -67,  101,   73,   47,   80,  -73, 
       68,   -1,   -8, -127, -107,  -44,   81, -105, 
       21, -128,  -71,   14, -105,  -31, -128,  112, 
       37,   92,  -43,   59,  112,  -74,    5,   80, 
      -56,  -18,   48,   15, -126,  -73,   84, -113, 
       77,   43,  -62,    4,   52,  -82,  -27,    2, 
     -104,   46,  117,  -40,  -73,   49,   91,  -27, 
       66,    9,  -50, -112,   47, -126,  101,  -55, 
       13, -104,   83,   -2,   12,  -18,  116,   37, 
     -115,   33,  110,  -54,    6,   48,   40,   65, 
      118,  -89,   60,  127,   -8,  -69,  -13,  -91, 
       32, -128,  -54,   15,  -34,  -49, -108,   -1, 
       36,   22,  -39,  -97,   43,   -2,  111,  -83, 
      -18,   23, -101,  -61, -117,   38,  -81,  115, 
       -7,   77,   71,   26,  -45,  -25,  -20, -125, 
      102,  -73,  -81,   -6,  -10, -105,  115, -105, 
      -13,  -19,  -60,  127,    1,  -67,  120,   85, 
      -44,  115,   70,    5,    0,   58,   -2,   91, 
     -119,  -30,   61,  -19,    8,   46,   73,  125, 
     -113,  -39,   66,  -53,  -30,   61,  -93,  -52, 
      -82,  -46,  -99,  104,   70,    6, -116,   11, 
      -49,    4,  -18, -117,   59,   17,  -24,   32, 
       28,  108,  -27,   20,   48,    0, -106, -126, 
      -60,  109, -126,   14,  103,  -73,    0, -100, 
       96,   30,   72,   87,  -96,   17,   12,    0, 
        0,   57,  -66,  -92,    7,   35,  -80,   -2, 
       46,   33,   72,  -96,   59,   -5,   88,   41, 
      -58,   -2,    4,   16,  -69,   64,  -99,  125, 
      -67,   -8,   25, -125,  -49,   62,  -63,    5, 
       -2,  -49,  -89, -123,   65, -126,  -28,  104, 
       39,   26,  -83,  -32,    3,  -85,  -82,   38, 
       76,   31,  -65,  -45,    1,  -64,   31,   96, 
     -126,    0,   66,  -13, -110,  -93,   94,  112, 
       26,  -82, -120,    1,   70, -101,  -10,  127, 
      -60,   45,  -33, -100,   -8,   64,  -35,  117, 
       79,  -26,   -3, -120,   39,   92,  -54,  -93, 
      -94, -121,  -56,  -81,  -34,   -3,   -9,  114, 
       11,  -50,   85, -126,   28,  -65, -119,  103, 
       90,  112,  111,  127,   80,   10,  -28,  -94, 
     -116, -121,   31,   27,  -35,   81,   70,   -8, 
       19,   -4, -114,   70,  -81,    2,  -51,   71, 
       37,  -50,   93, -127,   10,   63,   57,  -62, 
     -103,  111,  -12,   64,  -28,  -71,    0,  123, 
       68,   29,  -66,  -30,  -15,   69, -105,  -23, 
     -128,   45,   13,   19,  -80,  -50,   -8,    8, 
      -33, -104, -124,   83,   87,  -37,  119,   87, 
      110,  -64,   38,   76,    0,   63,  -38,   17, 
      -64,    5,  102, -125,  -16,    6,   93,  -85, 
       18,  125,   48,    0,   -1,   75,  -99,   94, 
     -118,    0,   15,  -52,  -64,   68,  -64, -126, 
        0,   67,   52,    3,   -7,  103, -126,    3, 
       75, -126,  114,  -10,   80,    0,  126,  100, 
       50,  -41,   89,  -30,    2,   90,  -29,  -14, 
     -100,  -96,   20,   -3,  -21,  -91,  -54,  114, 
        5,   -1,  123,    0,  100,  -72,    9,  -72, 
      -56,   69,  -24,   -3,    7,   15,  -64,   69, 
      119,  -85,   -7,  -36, -128,   15,  -34,  -70, 
       91,   21,  -16,   95,  -67, -127, -124,  -32, 
      126,    0,   93,   53,    0,  -83, -121, -126, 
       -3,  -20,   22,  -95,   19, -127,   -8,    1, 
     -128,  -12,    2,  -96,   63,    0,   33,   26, 
     -124,   76,   64,    0,    1,   20,   34,  -15, 
       11, -107, -128,    0,   34,  -63,   94, -119, 
       48,   32, -128,   16, -115,   64,  107,   14, 
        0,    0, -117,    1,  112,   31, -128,   23, 
      105, -119,  -34,  114,   19,    1,   74,   21, 
      107,   44,   56,   23,    2,   40,   97, -100, 
      -91,  -98,  119,  -16,   48,  127,  116,  -64, 
      -18,   98,  -71,   -2, -126,   36,   30, -126, 
      106,   26,  -87,  -12,  -96,   76,    8,  -69, 
       20,  -81,   50,   65,   72,  -89,   43,  -33, 
     -126,   -3,   95,  -38,  -26,   40,  -52,   13, 
        0,  -80,  -27,  106,   48,   64, -100,   28, 
      117,   85,   91,   -8,  -90,   18,   33, -103, 
      -35,   -8,   82,    6,   78,  -71,   30,   68, 
       88,    3, -120,  105,  -86,  -49,    7,   96, 
       72,  -68,  -22,  -16,  -93,    8,    5,   46, 
       73,   -7,  -89,  125,   -5,  -81,  -59,   98, 
       47,  -10,   25,  -65,  108,   11,  -46,    3, 
      -71, -118,   23,   -5,   60,  -41, -119,   -6, 
      -84,   11,  125,   48,   49, -105,  -80,   95, 
       59, -124,  -92,  102,  -70,  -65,   27,    9, 
      -32,  -99,  -57,    0,   79,  -33,  -45, -119, 
      -64,  -32,  127,  -95,  107,  -41,  123,   95, 
     -109,   15,  -75,   35,  -32,   80,  -72,   73, 
     -121,  -40,  -75,  -29,  -64,   56,   73, -123, 
      -77,   20,  125,  122,   62,   77,    8,    9, 
      -54, -113,  -19,   22,  -47,   73,  -62,   59, 
      113,  102,  -27,   16,  -37,   30,    3,  -79, 
      -25,   93,  117,   34,   21, -100,  120,   -7, 
      100,   86,  111, -124, -128,  121,   -2,   45, 
      -44,  -67,   42,    0,  -45,  -95,    1,    2, 
      127, -111,  101,  -78, -119,  -65,   12, -124, 
       24,  -43,  -13,   62,   85,   -5,   23,  -73, 
       70,   48,  105,    1,  -60,   26,  -33,  -77, 
      -27,   63,  -55,    7,  124,  -52,   -7,   95, 
      -13,   64,  -48, -127,    0,  111,  -44,   -4, 
       33,   42,   74,  -83,  -47,  -27,  -41,   64, 
       52, -106, -128,   15,  -88, -123, -128,   43, 
       33,  -21,    2,  114,  -17,   41,  126,  102, 
     -128,   55,  -86,   93,   10,  -88,  -29,  -31, 
       59,  -28,   55,  -11,  -93,  100, -121, -102, 
      -22,  -56,  -63,    7,   15,  -22, -127,  -20, 
        7,   -8,   30,  -37,   -1, -105,   28,  -68, 
     -100,  -88, -109,   -4,   75,  -17,  -32,   23, 
      -68,  -18,  -96,   45,  115,  108,   66,  118, 
       98,   44,   10,   48,   53,    0,   94,  -72, 
      -32,    5,  -51, -123,  -55,  -41,    7,   32, 
      108,  -62,  -76,    1,  121,  -92,   66,   24, 
      -75,  -91,   -6,   92,  115,   10,   22,   58, 
      -47,   63,   -3,   31,   85,    3,   46,  -29, 
      126,  -56,  -34,   93,   74,  -94,   96, -108, 
        4,  -76,   82,    8,   99,  115, -115, -115, 
       53, -102,   71,  120,   -4,  -58,   25,   77, 
      -80,  105,   -1,   69,  -34, -111,  -80, -115, 
        0,  111,   84,  -63,   28,  -57,   70,  107, 
       98,  -21,   95,   44, -104,   17,  -23,  -20, 
       16,  -68,  -15,  -38,  -65,  -82,  -17,   10, 
      -64,    2, -114,  -24,  -33,  -72, -113,  -37, 
       38, -108,   23,   28,   36,  -68,  -88,  110, 
      -13,  -84,   59,   98,  125,  -70,   25,  -91, 
      114,  -96,   62,  -48,    9,   63,   86, -127, 
     -126,  127,  107,  -69,  -56,  116,   64,  -81, 
      -57,   97,  -65,  100,  111,   33,   36,   51, 
       63,  -41,   -7,   16,    8,  105,  -93,  -13, 
     -126,   61,  114,    1,   84,  104,   10,   -1, 
       69,  -44,  125,   35,   17,   62, -119, -121, 
      -29,   62,  -39,   90,  126,  -17,  -34, -123, 
       75,   53,  -63,  122, -121,  -90,    2,   16, 
       15,   -6,    0,   87,   92,  -27,  -69,   48, 
       70,   67,   16,  -61,  126,   32,   32,  -72, 
      -85,  111,  -19,    1,   82,   24,  121,  -58, 
       -3,   64,   50,  -22,   71,  -90,  107,  -63, 
     -110,   30,   55,  114,  -34,  -96,   14,   58, 
     -116,   91, -113,   95,   -5,  -95,    2,   67, 
       77,  -25,   64,  -46,  -31,   13, -113,  -78, 
       -1, -116,  -28,   52,  -40,    9,  -95,   16, 
     -109,  -13,  -96,   80, -126,   66,  116,   56, 
       63,   83,  -71,   13,   42,   -3,    7,  -48, 
       72,  108,  -58,  -73,  -20,   65,   91,   52, 
       26,  -97,  -83,   -9,  -19,   66,  -51,  121, 
      113, -109,   86,   67,  -68,  118,  -93, -115, 
      105,   15,   -8,   65,   47,   90,   39,  125, 
       75,   78, -104,    8,  101,    6,   -3,  113, 
       95, -128,  -96,  -37,  -14,  -23,   28,  -47, 
       -2,  -32,   20,  -65, -110,   98,   71,  111, 
      120,   66,  127,   60, -108,   38,  125,   68, 
       41,  -93,   68,   68,  -81, -109,   93,  -35, 
       11,   12,  -25,  -92,   -1,   40,   17,  -40, 
      -79,   64,  111, -107,   33,  -89,  -54,    8, 
       15, -127,  -30,   18,   50,   41,   80,   58, 
        6,   76,   20,   66, -116,   16, -120,  -69, 
       64,   -4, -109,  111,  -10,   18,   26, -128, 
      -37,   63, -120,   61,  -42,  -31,  -93,   92, 
      -67,   -6, -127,  -96,   36,   80,  -17,  -96, 
       56,   80,  -99,  -17,  -65,    7, -100,  101, 
      126,  -78,   54,  -37,  -14, -115,  102,   30, 
       23,  -54, -121, -114,  -24,  -69, -126,  116, 
       17,  -65,  104,   11,   23,   41,  -44, -102, 
        2,  -65,  -47,  -63,    5,   67,   23,   89, 
       62,  -29,  -90,    4, -102,  114,    1,  -74, 
      -96,    1,   47,  111,  -60,  -60,   66,  -26, 
     -112,    5,   69,   -7,  -88,   97,  114,  -44, 
        0,  -68,   23,  -41,    5,  -35,  116,  -64, 
      -81,  127,  -20,   66,  -60,   55,  -69,  -65, 
      -11, -128,  -71,  -44,   99,  -56,  -11,  -96, 
     -127,   15,   27,  -71,  -17,   18,    8,   87, 
     -122,  -68,   39,   63,    2,   43, -127,   66, 
      106,   33,   62,   -5,  -16,   36,  -33, -108, 
       91, -128,  -48,  -87,   25,  -38,  104,    6, 
       -4,  -62,  -18,   91,  124,  -97,  -39,    6, 
      111, -119,   24,   53,  -95,  112,   62, -120, 
      -94,   39,  -68,   27,  121,  -58, -107,  -15, 
      120,  -21,  -60,   88, -118,   84,   26,  -61, 
       59,  -37,   19,  -12,  -43,  122,   16,  -82, 
       18,   97,  -10,   42, -111,  115, -114,  -14, 
       97,  -10,  -43,  120, -112,   11,  -14,   97, 
       -4,  -81,  -96, -124,   53,  -15,  -89,   67, 
      126,    4,   64,  -61,  -77,   93, -126,  -57, 
       10,   23,   -8,  -24,  111, -128,   48,   22, 
       94,  119, -114,  -28,  -33,   -3,  125,   67, 
      126,    1,   64,  114,  -14, -116,  111,   41, 
        1,  -56,   21,   66,    3,   -1,   63,  -61, 
      -13,  -44,  109,   18,   43,  -84,  -33,   69, 
      -87,    9,   -7,  100,   46,   11,  118,   54, 
     -102,  -56,  125, -102,   27,  -13, -117,   16, 
      -63,   37,    1,  -33,   -5,  124,  -92,  102, 
      -24,   63,   73,  107,  -91, -109,  109,   -5, 
      -63,   90,   16,   44,  -79,   64,   23,  -36, 
       80,   15,  -33,  -59,   40,  -35,    5,  -91, 
       58,  -20,  -28,   58,   19, -115,  -95,  -27, 
      -95, -112,  -42, -123,   96,   60,  -70,   67, 
       51,  -50,  -66,  -61,   65,    8,  -10,   61, 
      -83,  -28,   37,   51,    6,  -80, -112, -116, 
      -68,   28,  -28,   65,   16,   20,   66,    6, 
       66,   17,    8,  -62,   87,   72,  103, -123, 
      -72,   14,  100,   33, -120,    4,   17,    0, 
       34,    0,    0,    0,    4,   17,   88,  123, 
     -112,  116, -113,  -36,  -65,   33,  -65,   -1, 
     -128,   33,    0,   90,    0,    0,    0,    6, 
      -69,   82,  120, -101,  -69,  -20,  -66,  -77, 
      -92,   27,  -32,   81,  -81, -115,  -33,   -1, 
     -114,  -17,   81,  -76,  -71,  -28,   53,  -68, 
      -21,  116,    3,  125,   25,  -50, -123,   -4, 
      -36, -124,  -86,   47,   38,    3,  -15,  -90, 
      -68,  -47,    8,  -91,    3,   96,    7,  107, 
      -66,   67,  -95,   25,   24,  -33,   97,  -64, 
     -122, -109,   48,    7,  -18,  -60,   55,   20, 
      -61,  -53,  125,   33,   29,   -9,   -7,  -72, 
     -124,  -91,  -17,   38,    2,   17, -103,   -4, 
      -36,   72,   40,   80, -128,  -92,  -56,   66, 
       23,   -8,   34,    1,   12,  -32,  -37,   -4, 
      -84, -124,   50,  110, -124,  -81, -124,   95, 
     -128,   64,   16, -127,   40,   -6,   16,   31, 
       -7,   -2,   23, -114,  104,   58,   64,   18, 
       64,  -94,  -48,    0,    0,    0,   53, -102, 
     -109,  -60,  -32,   31,  -60,   37,  -99,    8, 
      -69,   -1,   77,  124,  109,   35,  -10,   92, 
      123, -119, -123,   47,  -74,  -56,  -75, -107, 
      -45,  -11,  -93,  -67,    9, -100,  -51,  -21, 
      -78,  -90,   67,   88,   89,    8,  -44,   65, 
      -44,    7,  -32,   74,   34,   55,  -66,  -37, 
      -96,   16,   61,  -60,    0,    5,   -2,   55, 
      -58, -115,  110,   -1,  -88,    7,   25,    1, 
      -52,   64,    3,  -19,    3,   84,   68,   -9, 
     -125,   64,   59,   56,    0,   24,    7,   64, 
       64,  102,    0,    0,    0,   98,    0,    0
    } ;
     
    private static final CompressedGeometryHeader cgHeader ;

    static {
     	cgHeader = new CompressedGeometryHeader() ;
     	cgHeader.majorVersionNumber = 1 ;
     	cgHeader.minorVersionNumber = 0 ;
     	cgHeader.minorMinorVersionNumber = 0 ;
     	cgHeader.bufferType = CompressedGeometryHeader.TRIANGLE_BUFFER ;
     	cgHeader.bufferDataPresent = CompressedGeometryHeader.NORMAL_IN_BUFFER ;
     	cgHeader.start = 0 ;
     	cgHeader.size = cgData.length ;
    }
}
