#
# Configuration stuff for linux-nfs
#

prefix=$(install_prefix)/
nfslibdir=$(prefix)/var/lib/nfs

##################################################################
# This is the prefix that will be used for nfsd and mountd. Leave this
# empty, or set to `k'.
KPREFIX		= k

# Optimization level for user space programs
#OPT		= -O2
OPT		= -g -O2

# Use these if you have an a.out compiler
CCMOD		:= $(CC)
LDMOD		:= $(LD)

# Statement of capabilities:
#
# HAVE_NETGROUPS	remove this if you have libc-4.5.26 or
#			earlier.
#
HAVE		= -DHAVE_NETGROUPS

# This define will turn NFSv3 support on or off one day. Not functional yet.
#NFSV3		= yes

# Where to install rpc.* daemons etc
BINDIR		= $(prefix)/bin
SBINDIR		= $(prefix)/sbin
USRSBINDIR	= $(prefix)/usr/sbin

# Where and how to install manpages
MANDIR		= $(prefix)/usr/man
MAN1EXT		= 1
MAN5EXT		= 5
MAN8EXT		= 8
MAN9EXT		= 9
MANOWNER	= root
MANGROUP	= root

################# END OF USER SERVICEABLE PARTS ##################
ALLTARGETS	= all clean distclean install installman \
		  depend dep postscript indent

ifndef ARCHFLAGS
  ARCH		= $(shell uname -m)
  FLAGS_i486	= -m486
  FLAGS_i586	= -m486
  FLAGS_alpha	= -mno-fp-regs -ffixed-8
  ARCHFLAGS	= $(FLAGS_$(ARCH))
.EXPORT:	ARCHFLAGS
endif

CC		= gcc
AR		= ar
LD		= ld
RM		= rm -f
MKDIR		= mkdir -p
LN_S		= ln -sf
RANLIB		= ranlib
INDENT		= indent
RPCGEN		= $(TOP)bin/rpcgen
GETKVER		= $(TOP)tools/getkversion
INSTALL		= install
MAN2PS		= groff -Tps -man

AFLAGS		= -I$(TOP)support/include \
		  -Wall $(ARCHFLAGS) -pipe $(HAVE)
ifdef KERNEL_INCDIR
AFLAGS	       += -I$(KERNEL_INCDIR)
endif

# -Wno-unused for 2.1.27 kernel cmsg_nexthdr... yuck.
CFLAGS		= $(OPT) -D_GNU_SOURCE $(AFLAGS) -Wno-unused $(CCOPTS)
LDFLAGS		= $(OPT) $(LDOPTS) -L$(TOP)support/lib

ifdef NFSV3
 CFLAGS	+= -DNFS3_SUPPORTED
endif

k		= $(KPREFIX)

INSTALLBIN	= $(INSTALL) -m 755 -s
INSTALLSUID	= $(INSTALL) -m 4755
INSTALLMOD	= $(INSTALL) -m 600
INSTALLMAN	= $(INSTALL) -m 644
MAN1DIR		= $(MANDIR)/man$(MAN1EXT)
MAN5DIR		= $(MANDIR)/man$(MAN5EXT)
MAN8DIR		= $(MANDIR)/man$(MAN8EXT)
MAN9DIR		= $(MANDIR)/man$(MAN9EXT)
