# This rpm spec is only tested with nfs-server-2.2beta37-1.1.src.rpm
# and initscripts-3.78.1-2.src.rpm. You need the correct rc scripts
# for nfs server and client. You can find them in the packages
# mentioned above. This RPM spec file is for the modified RedHat 5.2
# with working support for Linux 2.2.
Summary: Kernel NFS server/client utilities
Name: knfsd
Version: 1.3.3b
Release: 1
Copyright: GPL
Group: Networking/Daemons
Source0: ftp://ftp.varesearch.com/pub/support/hjl/nfs/knfsd-%{version}.tar.gz
Buildroot: /var/tmp/nfs-root
Requires: portmap, initscripts = 3.78.1-3, nfs-server = 2.2beta37-1.1, nfs-server-clients = 2.2beta37-1.1
Prereq: nfs-server
Summary(de): NFS-Server-Dmonen
Summary(fr): Demon pour serveur NFS.
Summary(tr): NFS sunucu sreleri

%description
The NFS and mount daemons are used to create an NFS server which
can export filesystems to other machines.  This package is not
needed to mount NFS filesystems -- that functionality is already
in the Linux kernel.

%description -l de
Die NFS- und Mount-Dmonen werden zum Erstellen eines NFS-Servers 
benutzt, der Dateisysteme auf andere Computer exportieren kann. 
Dieses Paket wird zum Montieren von NFS-Dateisysteme nicht bentigt, 
da es sich um eine Funktion handelt, die bereits im Linux-Kernel  
eingebaut ist. 

%description -l fr
Les dmons NFS et mount servent  crer un serveur NFS qui peut
exporter des systmes de fichiers vers d'autres machines. Ce paquetage
n'est pas ncessaire pour monter des systmes de fichiers NFS
-- cette fonctionnalit est dj dans le noyau Linux.

%description -l tr
NFS ve mount sunucu sreleri Linux sisteminizde yer alan dosya sistemlerini
NFS kullanarak baka makinalara paylatrmanz salayan sunuculardr. Bu
paket ile bilgisayarnz bir NFS sunucusu olarak kullanabilirsiniz. Baka
sunuculardan NFS kullanarak dosya sistemlerini balayabilmeniz iin bu
programlara gerek yoktur; bu zellik ekirdek iinde yer almaktadr.

%prep
%setup -q

%build
make OPT="$RPM_OPT_FLAGS" 

%install

mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc0.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc1.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc2.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc3.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc4.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc5.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc6.d
mkdir -p $RPM_BUILD_ROOT/usr/man/man5
mkdir -p $RPM_BUILD_ROOT/usr/man/man8
make prefix=$RPM_BUILD_ROOT install

strip $RPM_BUILD_ROOT/usr/sbin/kexportfs
strip $RPM_BUILD_ROOT/usr/sbin/rpc.kmountd
strip $RPM_BUILD_ROOT/usr/sbin/rpc.knfsd 
strip $RPM_BUILD_ROOT/usr/sbin/rpc.kstatd 
strip $RPM_BUILD_ROOT/usr/sbin/rpc.krquotad
strip $RPM_BUILD_ROOT/usr/sbin/knfsstat
strip $RPM_BUILD_ROOT/usr/sbin/kshowmount
strip $RPM_BUILD_ROOT/usr/sbin/knhfsstone
touch $RPM_BUILD_ROOT/etc/exports
chmod 644 $RPM_BUILD_ROOT/etc/exports

install -m755 -o root -g root etc/rc.nfsd \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/nfs

ln -sf ../init.d/nfs $RPM_BUILD_ROOT/etc/rc.d/rc0.d/K20nfs
ln -sf ../init.d/nfs $RPM_BUILD_ROOT/etc/rc.d/rc1.d/K20nfs
ln -sf ../init.d/nfs $RPM_BUILD_ROOT/etc/rc.d/rc2.d/K20nfs
ln -sf ../init.d/nfs $RPM_BUILD_ROOT/etc/rc.d/rc3.d/S60nfs
ln -sf ../init.d/nfs $RPM_BUILD_ROOT/etc/rc.d/rc5.d/S60nfs
ln -sf ../init.d/nfs $RPM_BUILD_ROOT/etc/rc.d/rc6.d/K20nfs

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc NEW README
%config /etc/exports

# %config /etc/rc.d/init.d/nfs
%config(missingok) /etc/rc.d/rc0.d/K20nfs
%config(missingok) /etc/rc.d/rc1.d/K20nfs
%config(missingok) /etc/rc.d/rc2.d/K20nfs
%config(missingok) /etc/rc.d/rc3.d/S60nfs
%config(missingok) /etc/rc.d/rc5.d/S60nfs
%config(missingok) /etc/rc.d/rc6.d/K20nfs

/usr/sbin/kexportfs
/usr/sbin/rpc.kmountd
/usr/sbin/rpc.knfsd
/usr/sbin/rpc.kstatd
/usr/sbin/knfsstat
/usr/sbin/rpc.krquotad
/usr/sbin/kshowmount
/usr/sbin/knhfsstone
/usr/man/man8/exportfs.8
/usr/man/man8/nfsstat.8
/usr/man/man8/rpc.rquotad.8
/usr/man/man8/rquotad.8
#/usr/man/man8/showmount.8
/usr/man/man5/exports.5

%post
if [ ! -f /etc/rc.d/init.d/nfs -o x"`grep KNFSD /etc/rc.d/init.d/nfs`" = x ]; then
  echo "Need /etc/rc.d/init.d/nfs with knfsd support."
  exit 1;
fi
if [ ! -d /var/lib/nfs ]; then
  mkdir -p /var/lib/nfs
fi
touch /var/lib/nfs/xtab
chown root.root /var/lib/nfs/xtab
chmod 644 /var/lib/nfs/xtab

%changelog
* Sun Jun  6 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.3.3b release.

* Thu Jun  3 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.3.3a release.

* Fri May 28 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.3.3 release.

* Mon May 17 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.3.2 release.

* Mon May 10 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.3a release.

* Sun May  9 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.3 release.

* Sat Apr 10 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.2.2a release.

* Wed Apr  7 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.2.2 release.

* Mon Mar 15 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.2 release.

* Fri Mar  5 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.1 release.

* Thu Feb 11 1999 H.J. Lu <hjl@varesearch.com>
- Make the 1.0 release.
