/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	GDB
 *
 *	$Id: fl_main.c,v 6.2 1998/05/26 04:38:07 lam Exp $
 * 
 *	Function:	- flat storage server
 */

#include <signal.h>
#include <stdlib.h>

#include <kreq.h>
#include <laminternal.h>
#include <priority.h>
#include <terror.h>

/*
 * external functions
 */
extern void		(*(fl_init()))();
extern void		(*(flatd()))();
extern void		flwipe();

/*
 * local functions
 */
static void		flbail();


int
main(argc, argv)

int			argc;
char			*argv[];

{
	_lam_signal(SIGHUP, flbail);
/*
 * Attach to kernel.
 */
	if (kinit(PRDAEMON)) lampanic("flatd (kinit)");
/*
 * Initialize.
 */
	fl_init(&argc, argv);
/*
 * server loop
 */
	for (;;) {

		if (!flatd()) {
			kexit(1);
			break;
		}
	}

	return(0);
}

/*
 *	flbail
 *
 *	Function:	- cleanup before exiting
 */
static void
flbail()

{
	flwipe();
	exit(0);
}
