/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	GDB
 *
 *	$Id: few.c,v 6.2 1998/05/26 04:50:34 lam Exp $
 * 
 *	Function:	- forks, execs and waits for a subordinate program
 *	Accepts:	- argument vector, argv[0] is program
 *	Returns:	- status code or ERROR
 */

#include <errno.h>
#include <sys/wait.h>
#include <stdlib.h>
#include <unistd.h>

int
_lam_few(argv)

char			*argv[];

{
	int		status;		/* exit status */
	int		pid;		/* whoami? */

	if ((pid = fork()) < 0) {
		return(pid);
    	}

	else if (pid == 0) {		/* child */
		execvp(argv[0], argv);
		exit(errno);
    	}

	else {				/* parent */

		while ((waitpid(pid, &status, 0) != 0) &&
				(! WIFEXITED(status)));
	}

	return(WEXITSTATUS(status));
}
