/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: laminternal.h,v 0.2 1997/11/24 23:57:38 lam Exp $
 *
 *	Function:	- prototypes for internally used LAM functions
 */

#ifndef _LAM_INTERNAL_H
#define _LAM_INTERNAL_H

#include <sys/types.h>
#include <sys/uio.h>

#include <kreq.h>
#include <portable.h>
#include <tstdio.h>
#include <typical.h>

#ifndef __ARGS
#if __STDC__ || defined(c_plusplus) || defined(__cplusplus)
#define __ARGS(a)	a
#else
#define __ARGS(a)	()
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Linux defines the second arument to gethostname() as size_t and
 * Solaris as int. Sigh.
 */
extern int 	gethostname();

extern char	*getworkdir __ARGS((void));
extern int	getinetaddr __ARGS((char *, unsigned char *));

extern char	*killname __ARGS((void));
extern char 	*sockname __ARGS((void));

extern int	lam_mktmpid __ARGS((int, char *, unint));

extern void	(*(_lam_signal())) __ARGS((int, void (*) ()));

extern int4	stoi __ARGS((unsigned char *));

extern void	nodespin_init __ARGS((char *));
extern void	nodespin_next __ARGS((int4));
extern void	nodespin_end __ARGS((void));

extern void	_cio_cleanup __ARGS((void));
extern void	_cio_bail __ARGS((int));
extern int	_cipc_ksrfront __ARGS((struct kreq *, struct kreply *));
extern int	_cipc_ksrback __ARGS((struct kreq *, struct kreply *));

extern off_t 	lam_iomap_lseek __ARGS((unsigned int, int, off_t, int));
extern int 	lam_iomap_open __ARGS((unsigned int, char *, int, int));
extern int	lam_iomap_close __ARGS((unsigned int, int));
extern int 	lam_iomap_read __ARGS((unsigned int, int, char *, int));
extern int 	lam_iomap_write __ARGS((unsigned int, int, const char *, int));

extern void 	_getbuf __ARGS((register TFILE *));
extern int	_fmt __ARGS((TFILE *, char *, const char *, ...));

extern int	 mread __ARGS((int, char *, int4));
extern int	 mreadv __ARGS((int, struct iovec *, int));
extern int	 mwrite __ARGS((int, const char *, int));
extern int	 mwritev __ARGS((int, struct iovec *, int));

#ifdef __cplusplus
}
#endif

#endif	/* _LAM_INTERNAL_H */
