/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	RBD
 *
 *	$Id: attrdel.c,v 6.2 1998/05/26 05:02:15 lam Exp $
 *
 *	Function:	- delete attribute
 *			- detach attribute from communicator
 *	Accepts:	- communicator
 *			- attribute key
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>
#include <terror.h>


int
MPI_Attr_delete(comm, key)

MPI_Comm		comm;
int			key;

{
	int		err;

	lam_initerr_m();
	lam_setfunc_m(BLKMPIATTRDEL);

	err = MPI_Comm_delete_attr(comm, key);
	if (err != MPI_SUCCESS) {
		return(lam_errfunc(comm, BLKMPIATTRDEL, err));
	}

	lam_resetfunc_m(BLKMPIATTRDEL);
	return(MPI_SUCCESS);
}
