/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	RBD
 *
 *	$Id: attrget.c,v 6.2 1998/05/26 05:02:15 lam Exp $
 *
 *	Function:	- get attribute value
 *	Accepts:	- communicator
 *			- attribute key
 *			- attribute value (out)
 *			- found flag (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>


int
MPI_Attr_get(comm, key, value, found)

MPI_Comm		comm;
int			key;
void			*value;
int			*found;

{
	int		err;

	lam_initerr_m();
	lam_setfunc_m(BLKMPIATTRGET);

	err = MPI_Comm_get_attr(comm, key, value, found);
	if (err != MPI_SUCCESS) {
		return(lam_errfunc(comm, BLKMPIATTRGET, err));
	}

	lam_resetfunc_m(BLKMPIATTRGET);
	return(MPI_SUCCESS);
}
