/*
 *	Ohio Trollius
 *	Copyright 1996 The Ohio State University
 *	RBD
 *
 *	$Id: bufattach.c,v 6.1 1996/11/23 22:51:01 nevin Rel $
 *
 *	Function:	- attach buffer to process
 *	Accepts:	- buffer address
 *			- buffer size
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>

int
MPI_Buffer_attach(buf, size)

void			*buf;
int			size;

{
	int		err;			/* error code */

	lam_initerr();
	lam_setfunc(BLKMPIBUFATTACH);

	err = lam_bufattach(buf, size);
	if (err != MPI_SUCCESS) {
		return(lam_errfunc(MPI_COMM_WORLD, BLKMPIBUFATTACH, err));
	}

	lam_resetfunc(BLKMPIBUFATTACH);
	return(MPI_SUCCESS);
}
