/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: cfreekey.c,v 0.2 1998/03/16 00:43:45 lam Exp $
 *
 *	Function:	- free communicator attribute key
 *	Accepts:	- key value (in-out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>
#include <terror.h>

int
MPI_Comm_free_keyval(key)

int			*key;

{
	int		err;
	
	lam_initerr();
	lam_setfunc(BLKMPICOMMFREEKEYVAL);
/*
 * Check the arguments.
 */
	if (key == 0) {
		return(lam_err_comm(MPI_COMM_WORLD, MPI_ERR_ARG, 0,
			"null pointer"));
	}
/*
 * Free the key, if it is valid.
 */
	if ((err = lam_freekey(*key, LAM_AKCOMM)) != MPI_SUCCESS) {
		return(lam_err_comm(MPI_COMM_WORLD, MPI_ERR_KEYVAL, 0, ""));
	}

	*key = MPI_KEYVAL_INVALID;

	lam_resetfunc(BLKMPICOMMFREEKEYVAL);
	return(MPI_SUCCESS);
}
