/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: cgetname.c,v 0.1 1998/03/16 00:51:43 lam Exp $
 *
 *	Function:	- get communicator name
 *	Accepts:	- communicator
 *			- communicator name (out)
 *			- communicator name length (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <string.h>

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>


int
MPI_Comm_get_name(comm, name, length)

MPI_Comm		comm;
char			*name;
int			*length;

{
	lam_initerr_m();
	lam_setfunc_m(BLKMPICOMMGETNAME);
/*
 * Check the arguments.
 */
	if (comm == MPI_COMM_NULL) {
		return(lam_errfunc(MPI_COMM_WORLD,
			BLKMPICOMMGETNAME, lam_mkerr(MPI_ERR_COMM, 0)));
	}

	if ((name == 0) || (length == 0)) {
		return(lam_errfunc(comm,
			BLKMPICOMMGETNAME, lam_mkerr(MPI_ERR_ARG, 0)));
	}

	strncpy(name, comm->c_name, MPI_MAX_OBJECT_NAME);
	name[MPI_MAX_OBJECT_NAME - 1] = 0;
	*length = strlen(name);

	lam_resetfunc_m(BLKMPICOMMGETNAME);
	return(MPI_SUCCESS);
}
