/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	RBD/NJN
 *
 *	$Id: dupfn.c,v 6.2 1998/05/26 05:02:15 lam Exp $
 *
 *	Function:	- pre-defined simple attribute copy functions
 *	Accepts:	- communicator/datatytpe/window
 *			- key value
 *			- extra state info
 *			- in attribute value
 *			- out attribute value (out)
 *			- flag (out)
 *	Returns:	- MPI_SUCCESS
 */

#include <mpi.h>

int
MPI_DUP_FN(comm, key, extra, attrin, attrout, flag)

MPI_Comm		comm;
int			key;
void			*extra;
void			*attrin;
void			*attrout;
int			*flag;

{
	*flag = 1;
	*((void **) attrout) = attrin;

	return(MPI_SUCCESS);
}

int
MPI_COMM_DUP_FN(comm, key, extra, attrin, attrout, flag)

MPI_Comm		comm;
int			key;
void			*extra;
void			*attrin;
void			*attrout;
int			*flag;

{
	*flag = 1;
	*((void **) attrout) = attrin;

	return(MPI_SUCCESS);
}

int
MPI_TYPE_DUP_FN(dtype, key, extra, attrin, attrout, flag)

MPI_Datatype		dtype;
int			key;
void			*extra;
void			*attrin;
void			*attrout;
int			*flag;

{
	*flag = 1;
	*((void **) attrout) = attrin;

	return(MPI_SUCCESS);
}

int
MPI_WIN_DUP_FN(win, key, extra, attrin, attrout, flag)

MPI_Win			win;
int			key;
void			*extra;
void			*attrin;
void			*attrout;
int			*flag;

{
	*flag = 1;
	*((void **) attrout) = attrin;

	return(MPI_SUCCESS);
}
