/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: connect_f.c,v 6.2 1998/05/26 05:03:54 lam Exp $
 *
 *	Function:	- MPI_Comm_connect F77 wrapper
 */

#include <lam_config.h>

#include <errno.h>
#include <stdlib.h>

#include <blktype.h>
#include <mpi.h>
#include <MPISYS.h>
#include <mpisys.h>

void
mpi_comm_connect_(port, info, root, comm, icomm, ierr, n)

char			*port;
int			*info, *root, *comm, *icomm, *ierr;
int			n;

{
	MPI_Comm	intercomm;
	char		*port_name;

	port_name = lam_F2C_string(port, n);
	if (port_name == 0) {
		lam_setfunc_m(BLKMPICOMMCONNECT);
		*ierr = lam_errfunc(GETHDL(*comm), BLKMPICOMMCONNECT,
					lam_mkerr(MPI_ERR_OTHER, errno));
		return;
	}

	*ierr = MPI_Comm_connect(port_name, GETHDL(*info),
				*root, GETHDL(*comm), &intercomm);
	
	if (lam_F_make_hdl(icomm, ierr, intercomm, BLKMPICOMMCONNECT)) {
		intercomm->c_f77handle = *icomm;
	}

	free(port_name);
}
