/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN/RBD
 *
 *	$Id: startall_f.c,v 6.2 1998/05/26 05:03:54 lam Exp $
 *
 *	Function:	- MPI_Startall F77 wrapper
 */

#include <lam_config.h>

#include <errno.h>
#include <stdlib.h>

#include <blktype.h>
#include <mpi.h>
#include <MPISYS.h>
#include <mpisys.h>

void
mpi_startall_(c, r, ierr)

int	*c, *r, *ierr;


{
	MPI_Request	*rq;
	int		i;

	if (*c > 0) {
		rq = (MPI_Request *) malloc((*c) * sizeof(MPI_Request));
		if (rq == 0) {
			lam_setfunc_m(BLKMPISTARTALL);
			*ierr = lam_errfunc(MPI_COMM_WORLD, BLKMPISTARTALL,
					lam_mkerr(MPI_ERR_OTHER, errno));
			return;
		}
	} else {
		rq = 0;
	}

	for (i = 0; i < *c; ++i) {
		rq[i] = GETHDL(r[i]);
	}
	
	*ierr = MPI_Startall(*c, rq);

	free((char *) rq);
}
