/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: tcreatestruct_f.c,v 0.2 1998/03/16 00:55:42 lam Exp $
 *
 *	Function:	- MPI_Type_create_struct F77 wrapper
 */

#include <errno.h>
#include <stdlib.h>

#include <blktype.h>
#include <mpi.h>
#include <MPISYS.h>
#include <mpisys.h>

void
mpi_type_create_struct_(c, b, d, t, nt, ierr)

int			*c, *b, *t, *nt, *ierr;
MPI_Aint		*d;

{
	MPI_Datatype	dtype;
	MPI_Datatype	*tp;
	int		i;

	if (*c > 0) {
		tp = (MPI_Datatype *) malloc((*c) * sizeof(MPI_Datatype));
		if (tp == 0) {
			lam_setfunc(BLKMPITCREATESTRUCT);
			*ierr = lam_errfunc(MPI_COMM_WORLD, BLKMPITCREATESTRUCT,
					lam_mkerr(MPI_ERR_OTHER, errno));
			return;
		}
	} else {
		tp = 0;
	}
	
	for (i = 0; i < *c; ++i) {
		tp[i] = GETHDL(t[i]);
	}

	*ierr = MPI_Type_create_struct(*c, b, d, tp, &dtype);

	if (lam_F_make_hdl(nt, ierr, dtype, BLKMPITCREATESTRUCT)) {
		dtype->dt_f77handle = *nt;
	}

	free((char *) tp);
}
