/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio	State University
 *	RBD/NJN
 *
 *	$Id: test_f.c,v 6.2 1998/05/26 05:03:54 lam Exp $
 *
 *	Function:	- MPI_Test F77 wrapper
 */

#include <lam_config.h>

#include <blktype.h>
#include <mpi.h>
#include <MPISYS.h>
#include <mpisys.h>

void
mpi_test_(rq, f, st, ierr)

int	*rq, *f, *st, *ierr;

{
	MPI_Request	req;
	MPI_Status	*stat;

	if ((void *) st == lam_F_status_ignore) {
		stat = MPI_STATUS_IGNORE;
	} else if ((void *) st == lam_F_statuses_ignore) {
		lam_setfunc(BLKMPITEST);
		*ierr = lam_err_comm(MPI_COMM_WORLD, MPI_ERR_ARG, 0,
					"MPI_STATUSES_IGNORE");
		return;
	} else {
		stat = (MPI_Status *) st;
	}

	req = GETHDL(*rq);
	*ierr =	MPI_Test(&req, f, stat);

	if (*ierr == MPI_SUCCESS && req	== MPI_REQUEST_NULL) {
		lam_F_free_hdl(*rq);
		*rq = -1;
	}
}
