/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: infogetnth.c,v 6.2 1998/05/26 05:02:15 lam Exp $
 *
 *	Function:	- get n'th key in info object
 *	Accepts:	- info
 *			- n
 *			- key (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <string.h>

#include <all_list.h>
#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>


int
MPI_Info_get_nthkey(info, n, key)

MPI_Info		info;
int			n;
char			*key;

{
	struct _infoent	*p;			/* key/value pair */
	
	lam_initerr_m();
	lam_setfunc_m(BLKMPIINFOGETNTHKEY);

	if (info == 0 || n >= al_count(info->info_list) || key == 0) {
		return(lam_errfunc(MPI_COMM_WORLD, BLKMPIINFOGETNTHKEY,
					lam_mkerr(MPI_ERR_ARG, 0)));
	}

	for (p = al_top(info->info_list); n > 0; n--) {
		p = al_next(info->info_list, p);
	}

	strcpy(key, p->ie_key);

	lam_resetfunc_m(BLKMPIINFOGETNTHKEY);
	return(MPI_SUCCESS);
}
