/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: keyfree.c,v 6.2 1998/05/26 05:02:15 lam Exp $
 *
 *	Function:	- free attribute key
 *	Accepts:	- key value (in-out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>
#include <terror.h>

int
MPI_Keyval_free(key)

int			*key;

{
	int		err;
	
	lam_initerr();
	lam_setfunc(BLKMPIKEYFREE);

	err = MPI_Comm_free_keyval(key);

	if (err != MPI_SUCCESS) {
	    return(lam_errfunc(MPI_COMM_WORLD, BLKMPIKEYFREE, err));
	}

	lam_resetfunc(BLKMPIKEYFREE);
	return(MPI_SUCCESS);
}
