/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: lampublish.c,v 0.1 1997/08/24 21:00:26 lam Exp $
 *
 *	Function:	- LAM MPI name publishing
 *			- all MPI services are published on node 0
 */

#include <lam_config.h>
#include <app_mgmt.h>
#include <mpisys.h>
#include <rpisys.h>
#include <trreq.h>

/*
 *	lam_publish
 *
 *	Function:	- publish a service
 *	Accepts:	- service name
 *			- service port
 *	Returns:	- 0 or LAMERROR
 */
int
lam_publish(name, port)

char			*name;
char			*port;

{
	int4		id;			/* name publishing ID */

	id = (int4) ((lam_myproc->p_gps.gps_pid << 16)
			| lam_myproc->p_gps.gps_node);

	return(lam_rtrnamepub(0, id, name, port));
}

/*
 *	lam_unpublish
 *
 *	Function:	- un-publish a service
 *	Accepts:	- service name
 *	Returns:	- 0 or LAMERROR
 */
int
lam_unpublish(name)

char			*name;

{
	return(lam_rtrnamedel(0, name));
}

/*
 *	lam_getpublished
 *
 *	Function:	- get a published port
 *			- allocates storage for the port
 *	Accepts:	- service name
 *			- service port (out)
 *	Returns:	- 0 or LAMERROR
 */
int
lam_getpublished(name, port)

char			*name;
char			**port;

{
	return(lam_rtrnameget(0, name, port));
}

/*
 *	lam_nukepublished
 *
 *	Function:	- nuke all names published by caller
 */
void
lam_nukepublished()

{
	int4		id;			/* name publishing ID */

	id = (int4) ((lam_myproc->p_gps.gps_pid << 16)
			| lam_myproc->p_gps.gps_node);

	lam_rtrnamesweep(0, id);
}
