/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: namelook.c,v 6.2 1998/05/26 05:02:15 lam Exp $
 *
 *	Function:	- get port name associated with service name
 *	Accepts:	- service name
 *			- info
 *			- port name (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>


int
MPI_Lookup_name(service_name, info, port_name)

char			*service_name;
MPI_Info		info;
char			*port_name;

{
	char		*port_buf;
	
	lam_initerr();
	lam_setfunc(BLKMPILOOKUPNAME);
/*
 * Check arguments.
 */
	if (port_name == 0 || service_name == 0) {
		return(lam_err_comm(MPI_COMM_WORLD, MPI_ERR_ARG, 0, ""));
	}
/*
 * Get port name.
 */
	if (lam_getpublished(service_name, &port_buf)) {
		return(lam_err_comm(MPI_COMM_WORLD, MPI_ERR_NAME, errno, "")); 
	}

	strncpy(port_name, port_buf, MPI_MAX_NAME_LEN);
	free(port_buf);

        lam_resetfunc(BLKMPILOOKUPNAME);
	return(MPI_SUCCESS);
}
