/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: namepub.c,v 6.2 1998/05/26 05:02:15 lam Exp $
 *
 *	Function:	- publish a port/service pair
 *	Accepts:	- service name
 *			- info
 *			- port name
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <errno.h>

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>

int
MPI_Publish_name(service_name, info, port_name)

char			*service_name;
MPI_Info		info;
char			*port_name;

{
	lam_initerr();
	lam_setfunc(BLKMPIPUBLISHNAME);
/*
 * Check arguments.
 */
	if (port_name == 0 || service_name == 0) {
		return(lam_errfunc(MPI_COMM_WORLD, BLKMPIPUBLISHNAME,
				lam_mkerr(MPI_ERR_ARG, 0)));
	}
/*
 * Publish name.
 */
	if (lam_publish(service_name, port_name)) {
		return(lam_errfunc(MPI_COMM_WORLD, BLKMPIPUBLISHNAME,
				lam_mkerr(MPI_ERR_SERVICE, errno))); 
	}

        lam_resetfunc(BLKMPIPUBLISHNAME);
	return(MPI_SUCCESS);
}
