/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: nameunpub.c,v 6.2 1998/05/26 05:02:15 lam Exp $
 *
 *	Function:	- unpublish a port/service pair
 *	Accepts:	- service name
 *			- info
 *			- port name
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <errno.h>

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>


int
MPI_Unpublish_name(service_name, info, port_name)

char			*service_name;
MPI_Info		info;
char			*port_name;

{
	lam_initerr();
	lam_setfunc(BLKMPIUNPUBLISHNAME);
/*
 * Check arguments.
 */
	if (service_name == 0) {
		return(lam_errfunc(MPI_COMM_WORLD, BLKMPIUNPUBLISHNAME,
					lam_mkerr(MPI_ERR_ARG, 0)));
	}
/*
 * We do not allow multiple ports for the same service name and hence
 * ignore the port name argument.
 */
	if (lam_unpublish(service_name)) {
		return(lam_errfunc(MPI_COMM_WORLD, BLKMPIUNPUBLISHNAME,
				lam_mkerr(MPI_ERR_SERVICE, errno))); 
	}

        lam_resetfunc(BLKMPIUNPUBLISHNAME);
	return(MPI_SUCCESS);
}
