/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: tcreatekey.c,v 0.4 1998/10/16 11:02:47 lamteam Exp $
 *
 *	Function:	- create a datatype attribute key
 *	Accepts:	- copy function
 *			- delete function
 *			- key (out)
 *			- extra state info
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>


int
MPI_Type_create_keyval(cpyfunc, delfunc, key, extra)

MPI_Type_copy_attr_function	*cpyfunc;
MPI_Type_delete_attr_function	*delfunc;
int				*key;
void				*extra;

{
        int 		err;

	lam_initerr_m();
	lam_setfunc_m(BLKMPITCREATEKEYVAL);

	err = lam_keyval_create((void_fn *) cpyfunc, (void_fn *) delfunc, 
				key, extra, LAM_AKTYPE);

	if (err != MPI_SUCCESS) {
		return(lam_errfunc(MPI_COMM_WORLD, BLKMPITCREATEKEYVAL, err));
	}

	lam_resetfunc_m(BLKMPITCREATEKEYVAL);
	return(MPI_SUCCESS);
}
