/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: tfreekey.c,v 0.2 1998/03/16 00:49:14 lam Exp $
 *
 *	Function:	- free datatype attribute key
 *	Accepts:	- key value (in-out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>
#include <terror.h>

int
MPI_Type_free_keyval(key)

int			*key;

{
	int		err;
	
	lam_initerr();
	lam_setfunc(BLKMPITFREEKEYVAL);
/*
 * Check the arguments.
 */
	if (key == 0) {
		return(lam_errfunc(MPI_COMM_WORLD,
			BLKMPITFREEKEYVAL, lam_mkerr(MPI_ERR_ARG, 0)));
	}
/*
 * Free the key, if it is valid.
 */
	if ((err = lam_freekey(*key, LAM_AKTYPE)) != MPI_SUCCESS) {
		return(lam_errfunc(MPI_COMM_WORLD, BLKMPITFREEKEYVAL, err));
	}

	*key = MPI_KEYVAL_INVALID;

	lam_resetfunc(BLKMPITFREEKEYVAL);
	return(MPI_SUCCESS);
}
