/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: tgetname.c,v 0.1 1998/03/16 00:51:43 lam Exp $
 *
 *	Function:	- get datatype name
 *	Accepts:	- datatype
 *			- datatype name (out)
 *			- datatype name length (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <string.h>

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>


int
MPI_Type_get_name(type, name, length)

MPI_Datatype		type;
char			*name;
int			*length;

{
	lam_initerr_m();
	lam_setfunc_m(BLKMPITGETNAME);
/*
 * Check the arguments.
 */
	if (type == MPI_DATATYPE_NULL) {
		return(lam_errfunc(MPI_COMM_WORLD,
			BLKMPITGETNAME, lam_mkerr(MPI_ERR_TYPE, 0)));
	}

	if ((name == 0) || (length == 0)) {
		return(lam_errfunc(MPI_COMM_WORLD,
			BLKMPITGETNAME, lam_mkerr(MPI_ERR_ARG, 0)));
	}

	strncpy(name, type->dt_name, MPI_MAX_OBJECT_NAME);
	name[MPI_MAX_OBJECT_NAME - 1] = 0;
	*length = strlen(name);

	lam_resetfunc_m(BLKMPITGETNAME);
	return(MPI_SUCCESS);
}
