/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: tgettrue.c,v 0.2 1998/03/16 00:50:06 lam Exp $
 *
 *	Function:	- get true lower bound and extent of datatype
 *	Accepts:	- datatype
 *			- true lower bound (out)
 *			- true extent (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>

int
MPI_Type_get_true_extent(dtype, lb, extent)

MPI_Datatype		dtype;
MPI_Aint		*lb;
MPI_Aint		*extent;

{
	lam_initerr();
	lam_setfunc(BLKMPITTEXTENT);

	if (dtype == MPI_DATATYPE_NULL) {
		return(lam_errfunc(MPI_COMM_WORLD,
			BLKMPITTEXTENT, lam_mkerr(MPI_ERR_TYPE, 0)));
	}
	else if (lb == 0 || extent == 0) {
		return(lam_errfunc(MPI_COMM_WORLD,
			BLKMPITTEXTENT, lam_mkerr(MPI_ERR_ARG, 0)));
	}
	else {
		*lb = dtype->dt_datalow;
		*extent = dtype->dt_dataup - dtype->dt_datalow;
	}

	lam_resetfunc(BLKMPITTEXTENT);
	return(MPI_SUCCESS);
}
