/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: thvector.c,v 6.2 1998/05/26 05:02:15 lam Exp $
 *
 *	Function:	- create hvector derived datatype
 *	Accepts:	- # blocks
 *			- block length
 *			- block stride (in bytes)
 *			- element datatype
 *			- new datatype (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>


int
MPI_Type_hvector(count, length, stride, oldtype, newtype)

int			count;
int			length;
MPI_Aint		stride;
MPI_Datatype		oldtype;
MPI_Datatype		*newtype;

{
	int		err;

	lam_initerr_m();
	lam_setfunc_m(BLKMPITHVECTOR);

	err = MPI_Type_create_hvector(count, length, stride, oldtype, newtype);

	if (err != MPI_SUCCESS) {
		return(lam_errfunc(MPI_COMM_WORLD, BLKMPITHVECTOR, err));
	}

	(*newtype)->dt_format = LAM_DTHVECTOR;

	lam_resetfunc_m(BLKMPITHVECTOR);
	return(MPI_SUCCESS);
}
