/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: tstruct.c,v 6.2 1998/05/26 05:02:15 lam Exp $
 *
 *	Function:	- create struct derived datatype
 *	Accepts:	- # blocks
 *			- block length array
 *			- block displacement array (in bytes)
 *			- block element datatype array
 *			- new datatype (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>

int
MPI_Type_struct(count, lengths, disps, oldtypes, newtype)

int			count;
int			*lengths;
MPI_Aint		*disps;
MPI_Datatype		*oldtypes;
MPI_Datatype		*newtype;

{
	int		err;

	lam_initerr_m();
	lam_setfunc_m(BLKMPITSTRUCT);

	err = MPI_Type_create_struct(count, lengths, disps, oldtypes, newtype);

	if (err != MPI_SUCCESS) {
		return(lam_errfunc(MPI_COMM_WORLD, BLKMPITSTRUCT, err));
	}

	(*newtype)->dt_format = LAM_DTSTRUCT;

	lam_resetfunc_m(BLKMPITSTRUCT);
	return(MPI_SUCCESS);
}
