/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: wgeterr.c,v 0.2 1998/03/16 00:50:51 lam Exp $
 *
 *	Function:	- get error handler of window
 *	Accepts:	- communicator
 *			- error handler (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>

int
MPI_Win_get_errhandler(win, errhdl)

MPI_Win			win;
MPI_Errhandler		*errhdl;

{
	lam_initerr();
	lam_setfunc(BLKMPIWINGETERRHDL);
/*
 * Check the arguments.
 */
	if (win == MPI_WIN_NULL) {
		return(lam_errfunc(MPI_COMM_WORLD,
			BLKMPIWINGETERRHDL, lam_mkerr(MPI_ERR_WIN, 0)));
	}

	if (errhdl == 0) {
		return(lam_errfunc(win->w_comm,
			BLKMPIWINGETERRHDL, lam_mkerr(MPI_ERR_ARG, 0)));
	}
/*
 * Get the window's error handler.
 */
	*errhdl = win->w_errhdl;

	lam_resetfunc(BLKMPIWINGETERRHDL);
	return(MPI_SUCCESS);
}
