/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: wgetname.c,v 0.1 1998/03/16 00:51:43 lam Exp $
 *
 *	Function:	- get window name
 *	Accepts:	- window
 *			- window name (out)
 *			- window name length (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>


int
MPI_Win_get_name(win, name, length)

MPI_Win			win;
char			*name;
int			*length;

{
	int		err;

	lam_initerr_m();
	lam_setfunc_m(BLKMPIWINGETNAME);
/*
 * Check the arguments.
 */
	if (win == MPI_WIN_NULL) {
		return(lam_errfunc(MPI_COMM_WORLD,
			BLKMPIWINGETNAME, lam_mkerr(MPI_ERR_WIN, 0)));
	}

	err = MPI_Comm_get_name(win->w_comm, name, length);

	lam_resetfunc_m(BLKMPIWINGETNAME);
	return(err);
}
