/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: wgroup.c,v 0.2 1998/03/16 00:50:51 lam Exp $
 *
 *	Function:	- get window group
 *	Accepts:	- window
 *			- group (out)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>

int
MPI_Win_get_group(win, group)

MPI_Win			win;
MPI_Group		*group;

{
	lam_initerr();
	lam_setfunc(BLKMPIWINGETGROUP);

	if (win == MPI_WIN_NULL) {
		return(lam_err_comm(MPI_COMM_WORLD,
		    			MPI_ERR_WIN, 0, "null handle"));
	}

	if (group == 0) {
		return(lam_err_win(win, MPI_ERR_ARG, 0, "null group pointer"));
	}

	*group = win->w_comm->c_group;
	win->w_comm->c_group->g_refcount++;

	lam_resetfunc(BLKMPIWINGETGROUP);
  	return(MPI_SUCCESS);
}
