/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	NJN
 *
 *	$Id: wsetname.c,v 0.1 1998/03/16 00:51:43 lam Exp $
 *
 *	Function:	- set window name
 *	Accepts:	- window
 *			- window name
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <mpisys.h>


int
MPI_Win_set_name(win, name)

MPI_Win			win;
char			*name;

{
	int		err;

	lam_initerr_m();
	lam_setfunc_m(BLKMPIWINSETNAME);
/*
 * Check the arguments.
 */
	if (win == MPI_WIN_NULL) {
		return(lam_errfunc(MPI_COMM_WORLD,
			BLKMPIWINSETNAME, lam_mkerr(MPI_ERR_WIN, 0)));
	}

	err = MPI_Comm_set_name(win->w_comm, name);

	lam_resetfunc_m(BLKMPIWINSETNAME);
	return(err);
}
