/*
 *	Ohio Trollius
 *	Copyright 1997 The Ohio State University
 *	RBD/GDB
 *
 *	$Id: trecv.c,v 6.2 1998/05/26 04:56:11 lam Exp $
 * 
 *	Function:	- transport layer receive
 */

#include <portable.h>
#include <typical.h>
#include <net.h>

#include <unistd.h>

int
trecv(nhead)

struct nmsg		*nhead;		/* network message descriptor */

{
	struct nmsg	sync;		/* synchronization message */
	int		save_event;	/* saved message event */
	int		ret;		/* returned value */
/*
 * Receive "ready to send" message.
 */
	sync.nh_event = nhead->nh_event;
	sync.nh_type = nhead->nh_type;
	sync.nh_flags = DINT4DATA;
	sync.nh_length = 0;
	sync.nh_msg = (char *) 0;

	if (nrecv(&sync)) return(LAMERROR);
/*
 * Send "ready to receive" to sending party.  Include the event to be used.
 */
	sync.nh_node = sync.nh_data[0];
	sync.nh_event = sync.nh_data[1];
	sync.nh_type = 0;
	sync.nh_flags = DINT4DATA;
	sync.nh_data[0] = -getpid();

	if (nsend(&sync)) return(LAMERROR);
/*
 * Receive the data message using the new event.
 */
	save_event = nhead->nh_event;
	nhead->nh_event = -getpid();

	ret = nrecv(nhead);

	nhead->nh_event = save_event;
	return(ret);
}
